////////////////////////////////////////////////////////////////////////
// multischedule.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.multischedule")

// <%pre>
#line 1 "multischedule.ecpp"


#include <livefeatures.h>
#include <setup.h>
#include <tools.h>
#include <timers.h>
#include <epg_events.h>

using namespace vdrlive;

struct SchedEntry {
	std::string title;
	std::string short_description;
	std::string description;
	std::string description_trunc;
	std::string start;
	std::string end;
	std::string day;
	std::string epgid;
	bool truncated;
	bool has_timer;
	int start_row;
	int row_count;

	static SchedEntry DummyEntry(int start_row, int row_count) {
		SchedEntry en;
		en.start_row = start_row;
		en.row_count = row_count;
		// no title and no start time = dummy event
		en.title = "";
		en.start = "";
		return en;
	}
};

std::string				channel_groups_setting;
std::vector<std::string>		channel_groups_names;
std::vector< std::vector<int> >		channel_groups_numbers;
std::vector<std::string>		times_names;
std::vector<time_t>			times_start;

#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class channel_selection_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        channel_selection_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    channel_selection_type channel_selection;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("multischedule");

static const char* rawData = "X\001\000\000\304\001\000\000\317\001\000\000\322\001\000\000\325\001\000\000`\002\000"
  "\000\217\002\000\000\322\002\000\000\371\002\000\000\246\003\000\000\251\003\000\000\301\003\000\000\375\003\000\000O"
  "\004\000\000\226\004\000\000\306\004\000\000\307\004\000\000\310\004\000\000\326\004\000\000\327\004\000\000\343\004"
  "\000\000\360\004\000\000D\005\000\000R\005\000\000\213\005\000\000\216\005\000\000\227\005\000\000\230\005\000\000"
  "\243\005\000\000\262\005\000\000\357\005\000\000)\006\000\000\226\006\000\000\305\006\000\000\377\006\000\000l\007"
  "\000\000\260\007\000\000\340\007\000\000\353\007\000\000j\010\000\000k\010\000\000\255\010\000\000\271\010\000\000"
  "\302\010\000\000\312\010\000\000\000\t\000\000\032\t\000\000\036\t\000\000\134\t\000\000\211\t\000\000\212\t\000\000"
  "\225\t\000\000\315\t\000\000\324\t\000\000\022\n\000\000\026\n\000\0004\n\000\0006\n\000\000;\n\000\000]\n\000\000"
  "\244\n\000\000\263\n\000\000\273\n\000\000,\013\000\000[\013\000\000\134\013\000\000]\013\000\000\277\013\000\000A"
  "\014\000\000R\014\000\000T\014\000\000k\014\000\000\204\014\000\000\216\014\000\000\271\014\000\000\?\015\000\000P"
  "\015\000\000R\015\000\000i\015\000\000\202\015\000\000\214\015\000\000\311\015\000\000\320\015\000\000\354\015\000"
  "\000\363\015\000\000\364\015\000\000\n<html>\n\t<head>\n\t<meta name=\"viewport\" content=\"width=device-width, initi"
  "al-scale=1\" />\n\t\t<title>VDR Live - </title>\n\t\t\n\t\t\n\t\t\n\t\t<script type=\"text/javascript\"><!--\n\t\tfun"
  "ction KeyboardInput(ev) {\n\t\t\tif (ev.ctrlKey)\n\t\t\t\tswitch (ev.which) {\n\t\t\t\tcase 37: // left\n\t\t\t\t\t\n"
  "\t\t\t\t\treturn false;\n\t\t\t\tcase 39: // right\n\t\t\t\t\t\n\t\t\t\t\treturn false;\n\t\t\t\t}\n\t\t\t\tswitch (e"
  "v.key) {\n\t\t\t\tcase '<':\n\t\t\t\t\t\n\t\t\t\t\treturn false;\n\t\t\t\tcase '>':\n\t\t\t\t\t\n\t\t\t\t\treturn fal"
  "se;\n\t\t\t\t}\n\t\t\treturn true;\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body onload=\"adjustHeader()\" onresize="
  "\"adjustHeader()\" onkeydown=\"return KeyboardInput(event);\">\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t<table cl"
  "ass=\"mschedule\" cellspacing=\"0\" cellpadding=\"0\">\n\t       <tr class=\" topaligned \">\n\t       <td > <div cla"
  "ss=\"boxheader\"> <div><div></div></div> </div></td>\n\t       <td class=\"time spacer\"> &nbsp; </td>\n\t       <td>"
  " <div class=\"boxheader\"> <div> <div> \n              \n            \n            \n            </div></div> </div><"
  "/td>\n\t       <td class=\"time spacer\"> &nbsp; </td>\n\t       </tr>\n\t\t       <tr>\n\t\t       <td class=\" time"
  " leftcol rightcol \">\n\t\t       \n\t\t\t &nbsp;\n\t\t       </td>\n\t\t                <td class = \" time spacer "
  "\" > &nbsp; </td>\n\t\t\t<td class=\"event topaligned leftcol rightcol\" rowspan=\"\">\n                        <div "
  "class=\" content1 \" >\n                         <div class= \"start withmargin\"></div>\n                        </d"
  "iv>\n\t\t\t</td>\n\t\t\t<td class=\"event topaligned leftcol rightcol\" rowspan=\"\">\n                        <div c"
  "lass=\" content1 \" >\n                         <div class= \"start withmargin\"></div>\n                        </di"
  "v>\n                        </td>\n\t\t\t<td class=\"event topaligned leftcol rightcol \" rowspan=\"\">\n            "
  "            <div class=\" content1 \" >\n                        <div class=\" tools1 \" >\n                         "
  " \n                          <a href=\"searchresults.html\?searchplain=\"><img src=\"\" alt=\"\"  /></a>\n<img src=\""
  "img/transparent.png\" width=\"16\" height=\"16\">                          \n\t\t\t                         </div><di"
  "v class= \"start withmargin\"></div>\n\t\t\t  <div class=\"title withmargin\"><a ></a></div>\n                       "
  "   <div class=\"short withmargin\"></div>\n                          <div class=\"description withmargin\">...\n     "
  "                      <a > </a>\n                           </div>\n                          </div></div>\n         "
  "                 </td>\n\t\t       </tr>\n\t\t\t<tr>\n\t\t\t<td class = \" event leftcol rightcol bottomrow \" > &nbs"
  "p; </td>\n\t\t\t<td class = \" time spacer \" > &nbsp; </td>\n\t\t\t</tr>\n\t\t\t</table>\n\t\t</div>\n\t</body>\n</h"
  "tml>\n\n\n<form action=\"multischedule.html\" method=\"get\" id=\"channels\">\n   <span>\n     <label for=\"channel\""
  ">:&nbsp;<span class=\"bold\"></span></label>\n     <select name=\"channel\" id=\"channel\"  onchange=\"document.forms"
  ".channels.submit()\" >\n\t\t<option value=\"\"\n\t\t\tselected=\"selected\"\n                        ></option>\n    "
  " </select>\n     <label for=\"time_para\">:&nbsp;<span class=\"bold\"></span></label>\n     <select name=\"time_para"
  "\" id=\"time_para\"  onchange=\"document.forms.channels.submit()\" >\n\t\t<option value=\"\"\n\t\t\tselected=\"select"
  "ed\"\n                        ></option>\n     </select>\n   </span>\n</form>\n<span class=\"sep\">|</span>\n\302\253"
  " Prev\n<span class=\"sep\">|</span>\nNext \302\273\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    channel_selection(*this, "channel_selection")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("multischedule " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
int channel = qparam.get< int >("channel", ( -1));
unsigned int time_para = qparam.get< unsigned int >("time_para", ( 0));
  // </%args>

#line 47 "multischedule.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 50 "multischedule.ecpp"
  typedef unsigned int channel_group_type;
  TNT_REQUEST_SHARED_VAR(unsigned int, channel_group, (0));   // <%request> unsigned int channel_group(0)
  _tnt_ignore_unused<channel_group_type>(channel_group);
#line 51 "multischedule.ecpp"
  typedef unsigned int time_selected_type;
  TNT_REQUEST_SHARED_VAR(unsigned int, time_selected, (0));   // <%request> unsigned int time_selected(0)
  _tnt_ignore_unused<time_selected_type>(time_selected);
#line 52 "multischedule.ecpp"
  typedef cString prev_type;
  TNT_REQUEST_SHARED_VAR(cString, prev, ());   // <%request> cString prev
  _tnt_ignore_unused<prev_type>(prev);
#line 53 "multischedule.ecpp"
  typedef cString next_type;
  TNT_REQUEST_SHARED_VAR(cString, next, ());   // <%request> cString next
  _tnt_ignore_unused<next_type>(next);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 56 "multischedule.ecpp"

  reply.setHeader (tnt::httpheader::cacheControl, "no-store, no-cache, max-age=0, must-revalidate, proxy-revalidate", true);
	if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");
	pageTitle = tr("MultiSchedule");

#if VDRVERSNUM < 20301
	ReadLock channelsLock( Channels );
	if ( !channelsLock )
		throw HtmlError( tr("Couldn't aquire access to channels, please try again later.") );
#endif

#define MAX_CHANNELS 10
#define MAX_DAYS 3
#define MAX_HOURS 8
#define MINUTES_PER_ROW 5
#define CHARACTERS_PER_ROW 30

    if ( ( channel_groups_setting.compare(LiveSetup().GetChannelGroups()) != 0 ) || ( channel_groups_numbers.size() == 0 ) )
    {
#if VDRVERSNUM >= 20301
        LOCK_CHANNELS_READ;
#endif
        // build the groups of channels to display
        std::string channelGroups=LiveSetup().GetChannelGroups();
        if ( channelGroups.empty() )
        {
            // setup default channel groups
           int lastChannel = LiveSetup().GetLastChannel();
           if ( lastChannel == 0 )
#if VDRVERSNUM >= 20301
               lastChannel = Channels->MaxNumber();
#else
               lastChannel = Channels.MaxNumber();
#endif
           std::stringstream groups;
           int i = 0;
#if VDRVERSNUM >= 20301
           for (cChannel *channel = (cChannel *)Channels->First(); channel && (channel->Number() <= lastChannel); channel = (cChannel *)Channels->Next(channel))
#else
           for (cChannel *channel = Channels.First(); channel && (channel->Number() <= lastChannel); channel = Channels.Next(channel))
#endif
           {
               if (channel->GroupSep())
                   continue;
               groups << channel->Number();
               if ( (++i % 5) == 0 )
                   groups << ";";
               else
                   groups << ",";
           }
           channelGroups = groups.str();
           LiveSetup().SetChannelGroups( channelGroups );
        }
        channel_groups_names.clear();
        channel_groups_numbers.clear();
        channel_groups_setting = channelGroups;
        size_t groupSep;
        std::string thisGroup = "";
        while ( ! channelGroups.empty() )
        {
            groupSep = channelGroups.find(';');
            thisGroup = channelGroups.substr(0, groupSep );
            if ( groupSep != channelGroups.npos )
                channelGroups.erase(0, groupSep+1 );
            else
                channelGroups="";

            int cur_group_count=0;
            channel_groups_names.push_back( std::string() );
            channel_groups_numbers.push_back( std::vector<int>() );
            while ( !thisGroup.empty() )
            {
                std::string thisChannel;
                try {
                    size_t channelSep = thisGroup.find(',');
                    thisChannel = thisGroup.substr(0, channelSep );
                    if ( cur_group_count++ != 0 )
                        channel_groups_names.back() += std::string( " - " );
		    else
			channel_groups_names.back() += thisChannel += std::string( ": " );
                    if ( channelSep != thisGroup.npos )
                        thisGroup.erase( 0, channelSep+1 );
                    else
                        thisGroup = "";
                    int channel_no = parse_int< int > (thisChannel);
#if VDRVERSNUM >= 20301
                    cChannel* Channel = (cChannel *)Channels->GetByNumber( channel_no );
#else
                    cChannel* Channel = Channels.GetByNumber( channel_no );
#endif
                    if ( !Channel )
                    {
                        esyslog("live: could not find channel no '%s'.", thisChannel.c_str() );
                        continue;
                    }
                    channel_groups_names.back() += std::string( Channel->Name() );
                    channel_groups_numbers.back().push_back( Channel->Number() );
                    if ( cur_group_count>=MAX_CHANNELS )
                    {
                        // start new group if group gets too large
                        cur_group_count=0;
                        channel_groups_names.push_back( std::string() );
                        channel_groups_numbers.push_back( std::vector<int>() );
                    }
                }
                catch ( const bad_lexical_cast & )
                {
                    esyslog("live: could not convert '%s' into a channel number", thisChannel.c_str());
                    continue;
                }
            }
        }
    }

	if ( channel < 0 )
	{
		if (cDevice::CurrentChannel())
		{
            // find group corresponding to current channel
            int curGroup =0;
			int curChannel = cDevice::CurrentChannel();
            for ( std::vector< std::vector<int> >::iterator grIt = channel_groups_numbers.begin();
                  grIt != channel_groups_numbers.end() && channel < 0; ++grIt, ++curGroup )
            {
                for ( std::vector<int>::iterator chIt = (*grIt).begin();
                       chIt != (*grIt).end() && channel < 0; ++ chIt )
                {
                    if ( *chIt == curChannel )
                        channel_group = channel = curGroup;
                }
            }
            // if nothing is found, fall back to group 0
            if ( channel < 0 )
                channel = 0;
		}
		else
		{
            channel_group = channel;
		}
	}

	if ( channel >= (int)channel_groups_numbers.size() )
		channel = 0;
	channel_group = channel;

	{
		// build time list
		times_names.clear();
		times_start.clear();

		// calculate time of midnight (localtime) and convert back to GMT
		time_t now = (time(NULL)/3600)*3600;
		time_t now_local = time(NULL);
		struct tm tm_r;
		if ( localtime_r( &now_local, &tm_r ) == 0 ) {
			std::stringstream builder;
			builder << "cannot represent timestamp " << now_local << " as local time";
			throw std::runtime_error( builder.str() );
		}
		tm_r.tm_hour=0;
		tm_r.tm_min=0;
		tm_r.tm_sec=0;
		time_t midnight = mktime( &tm_r );

		// add four 8h steps per day to the time list
		for (int i=0; i<4*MAX_DAYS ; i++ )
		{
			times_start.push_back( midnight + MAX_HOURS*3600*i );
		}
		std::vector< std::string > parts = StringSplit( LiveSetup().GetTimes(), ';' );
		std::vector< time_t > offsets;
		std::vector< std::string >::const_iterator part = parts.begin();
		for ( ; part != parts.end(); ++part )
		{
			try {
				unsigned int sep = (*part).find(':');
				std::string hour = (*part).substr(0, sep );
				if ( sep == (*part).npos )
				{
					esyslog("live: Error parsing time '%s'", (*part).c_str() );
					continue;
				}
				std::string min = (*part).substr(sep+1, (*part).npos );
				offsets.push_back( parse_int<time_t>( hour )*60*60 + parse_int<time_t>( min ) *60 );
			}
			catch ( const bad_lexical_cast & ) {
				esyslog("live: Error parsing time '%s'", part->c_str() );
			};
		};
		// add the time of the favourites to the time list
		for (int i=0; i< MAX_DAYS ; i++ )
		{
			std::vector< time_t >::const_iterator offset = offsets.begin();
			for ( ; offset != offsets.end(); ++offset )
			{
				times_start.push_back( midnight + 24*3600*i + *offset );
			}
		}
		// add now
		times_start.push_back( now );
		// sort the times
		std::sort( times_start.begin(), times_start.end() );
		// delete every time which has already passed
		while ( *times_start.begin()< now )
			times_start.erase(times_start.begin() );

		// build the corresponding names
		for ( std::vector< time_t >::const_iterator start = times_start.begin();
			  start != times_start.end(); ++start )
		{
      cToSvConcat times_name;
      times_name.appendDateTime(tr("%A, %x"), *start);
      times_name.concat(' ');
      times_name.appendDateTime(tr("%I:%M %p"), *start);
			times_names.push_back(std::string(times_name));
		}
		// the first time is now
		times_names[0]=tr("Now");

		if ( time_para >= times_names.size() )
			time_para = times_names.size()-1;
		time_selected=time_para;
	}

	if (channel_group > 0)
		prev = cString::sprintf("href=\"multischedule.html?time_para=%i&channel=%i\"", time_selected, channel_group - 1);
	if (channel_group < channel_groups_numbers.size() - 1)
		next = cString::sprintf("href=\"multischedule.html?time_para=%i&channel=%i\"", time_selected, channel_group + 1);

  // <& pageelems.doc_type ...
  { 
#line 285 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 285 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[0]; // \n<html>\n\t<head>\n\t<meta name="viewport" content="width=device-width, initial-scale=1" />\n\t\t<title>VDR Live - 
#line 289 "multischedule.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 290 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 290 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 291 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 291 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n\t\t
  // <& pageelems.create_html_js ...
  { 
#line 292 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 292 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "create_html_js"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n\t\t<script type="text/javascript"><!--\n\t\tfunction KeyboardInput(ev) {\n\t\t\tif (ev.ctrlKey)\n\t\t\t\tswitch (ev.which) {\n\t\t\t\tcase 37: // left\n\t\t\t\t\t
#line 298 "multischedule.ecpp"
  if ( *prev )
    reply.out() <<  "window.location." << *prev ;
  reply.out() << _tntChunks[5]; // \n\t\t\t\t\treturn false;\n\t\t\t\tcase 39: // right\n\t\t\t\t\t
#line 301 "multischedule.ecpp"
  if ( *next )
    reply.out() <<  "window.location." << *next ;
  reply.out() << _tntChunks[6]; // \n\t\t\t\t\treturn false;\n\t\t\t\t}\n\t\t\t\tswitch (ev.key) {\n\t\t\t\tcase '<':\n\t\t\t\t\t
#line 306 "multischedule.ecpp"
  if ( *prev )
    reply.out() <<  "window.location." << *prev ;
  reply.out() << _tntChunks[7]; // \n\t\t\t\t\treturn false;\n\t\t\t\tcase '>':\n\t\t\t\t\t
#line 309 "multischedule.ecpp"
  if ( *next )
    reply.out() <<  "window.location." << *next ;
  reply.out() << _tntChunks[8]; // \n\t\t\t\t\treturn false;\n\t\t\t\t}\n\t\t\treturn true;\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body onload="adjustHeader()" onresize="adjustHeader()" onkeydown="return KeyboardInput(event);">\n\t\t
  // <& pageelems.logo ...
  { 
#line 317 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 317 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[9]; // \n\t\t
  // <& menu ...
  { 
#line 318 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 318 "multischedule.ecpp"
    _tnt_cq5.add( "active", ("multischedule"));
#line 318 "multischedule.ecpp"
    _tnt_cq5.add( "component", ("multischedule.channel_selection"));
#line 318 "multischedule.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[10]; // \n\t\t<div class="inhalt">\n
#line 320 "multischedule.ecpp"

#if VDRVERSNUM < 20301
	cSchedulesLock schedulesLock;
	cSchedules const* schedules = cSchedules::Schedules( schedulesLock );
#endif

	time_t now = time(NULL);
	if ( time_para >= times_start.size() )
	    time_para = times_start.size()-1;
	time_t sched_start = (times_start[ time_para ]/300)*300;
	time_t max_hours;
	try {
		max_hours = parse_int<time_t>( LiveSetup().GetScheduleDuration() );
	}
	catch ( const bad_lexical_cast & )
	{
		esyslog("live: could not convert '%s' into a schedule duration", LiveSetup().GetScheduleDuration().c_str());
		max_hours = 8;
	};
	if (max_hours > 48)
	    max_hours = 48;

	time_t sched_end = sched_start + 60 * 60 * max_hours;
	int sched_end_row = ( sched_end - sched_start ) / 60 / MINUTES_PER_ROW;
	std::list<SchedEntry> table[MAX_CHANNELS];
	std::vector<std::string> channel_names(channel_groups_numbers[ channel ].size() );
	std::vector<tChannelID> channel_IDs(channel_groups_numbers[ channel ].size() );
	if ( channel >= (int)channel_groups_numbers.size() )
		channel = channel_groups_numbers.size()-1;
	//for ( int chan = 0; chan<MAX_CHANNELS; chan++)
	for ( unsigned int j = 0; j<channel_groups_numbers[ channel ].size(); j++)
	{
		int prev_row = -1;
		int chan = channel_groups_numbers[ channel ][ j ];

		cChannel* Channel;
		{
			LOCK_CHANNELS_READ;
			Channel = (cChannel *)Channels->GetByNumber( chan );
		}
		if ( ! Channel )
			continue;
		if ( Channel->GroupSep() || !Channel->Name() || !*Channel->Name() )
			continue;
		channel_names[ j ] = Channel->Name();
		channel_IDs[ j ] = Channel->GetChannelID();

		cSchedule const* Schedule;
		{
			LOCK_SCHEDULES_READ;
			Schedule = Schedules->GetSchedule( Channel );
		}
		if ( ! Schedule )
		{
			// insert dummy event for the entire channel if no EPG data
			table[ j ].push_back( SchedEntry::DummyEntry(0 , sched_end_row));
			prev_row = sched_end_row;
			continue;
		}
		for (const cEvent *Event = Schedule->Events()->First(); Event;
			 Event = Schedule->Events()->Next(Event) )
		{
			if (Event->EndTime() <= sched_start )
				continue;
			if (Event->StartTime() >= sched_end )
				continue;

			EpgInfoPtr epgEvent = EpgEvents::CreateEpgInfo(Channel, Event);
			if ( prev_row < 0 && Event->StartTime() > sched_start + MINUTES_PER_ROW )
			{
				// insert dummy event at start
				table[ j ].push_back( SchedEntry() );
				SchedEntry &en=table[ j ].back();
				int event_start_row = (Event->StartTime() - sched_start) / 60 / MINUTES_PER_ROW;
				en.start_row = 0;
				en.row_count = event_start_row;
				if ( en.row_count < 1 )
					en.row_count = 1;
				// no title and no start time = dummy event
				en.title = "";
				en.start = "";
				prev_row = en.start_row + en.row_count;
			}
			table[ j ].push_back( SchedEntry() );
			SchedEntry &en=table[j].back();

			en.title = epgEvent->Title();
			en.short_description = epgEvent->ShortDescr();
			en.description = epgEvent->LongDescr();
			en.start = epgEvent->StartTime(tr("%I:%M %p"));
			en.end = epgEvent->EndTime(tr("%I:%M %p"));
			en.day = epgEvent->StartTime(tr("%A, %b %d %Y"));
			en.epgid = EpgEvents::EncodeDomId(Channel->GetChannelID(), Event->EventID());
			en.has_timer = LiveTimerManager().GetTimer(Event->EventID(), Channel->GetChannelID() ) != 0;

			en.start_row = prev_row > 0 ? prev_row : 0;
			int end_time = Schedule->Events()->Next(Event) ?
				Schedule->Events()->Next(Event)->StartTime() :
				Event->EndTime();
			if (end_time > sched_end)
				end_time = sched_end;
			int next_event_start_row = (end_time - sched_start) / 60 / MINUTES_PER_ROW;
			en.row_count = next_event_start_row - en.start_row;
			if ( en.row_count < 1 )
				en.row_count = 1;
			prev_row = en.start_row + en.row_count;

			// truncate description if too long
			en.truncated=false;
			en.description_trunc=StringWordTruncate( en.description,
													 CHARACTERS_PER_ROW*(en.row_count-2),
													 en.truncated );



		};
		if ( table[ j ].begin() == table[ j ].end() )
		{
			// no entries... create a single dummy entry
			table[ j ].push_back( SchedEntry() );
			SchedEntry &en=table[ j ].back();
			en.start_row = 0;
			en.row_count = sched_end_row;
			// no title and no start time = dummy event
			en.title = "";
			en.start = "";
		}
	}

  reply.out() << _tntChunks[11]; // \t\t<table class="mschedule" cellspacing="0" cellpadding="0">\n
#line 450 "multischedule.ecpp"


  reply.out() << _tntChunks[12]; // \t       <tr class=" topaligned ">\n\t       <td > <div class="boxheader"> <div><div>
#line 453 "multischedule.ecpp"
  reply.sout() << ( tr("Time") );
  reply.out() << _tntChunks[13]; // </div></div> </div></td>\n\t       <td class="time spacer"> &nbsp; </td>\n
#line 455 "multischedule.ecpp"

                for ( unsigned int channel = 0; channel< channel_names.size() ; channel++)
                {

  reply.out() << _tntChunks[14]; // \t       <td> <div class="boxheader"> <div> <div>
#line 459 "multischedule.ecpp"
  reply.sout() << ( channel_names[channel] );
  reply.out() << _tntChunks[15]; //  
  reply.out() << _tntChunks[16]; // \n
#line 460 "multischedule.ecpp"
           if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  reply.out() << _tntChunks[17]; //               
  // <& pageelems.ajax_action_href ...
  { 
#line 461 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 461 "multischedule.ecpp"
    _tnt_cq6.add( "action", "switch_channel");
#line 461 "multischedule.ecpp"
    _tnt_cq6.add( "alt", "");
#line 461 "multischedule.ecpp"
    _tnt_cq6.add( "image", "zap.png");
#line 461 "multischedule.ecpp"
    _tnt_cq6.add( "param", (channel_IDs[channel]));
#line 461 "multischedule.ecpp"
    _tnt_cq6.add( "tip", (tr("Switch to this channel.")));
#line 461 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[18]; // \n
#line 462 "multischedule.ecpp"
           }

  reply.out() << _tntChunks[19]; //             
  // <& pageelems.hls_channel ...
  { 
#line 463 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 463 "multischedule.ecpp"
    _tnt_cq7.add( "channelId", (channel_IDs[channel]));
#line 463 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_channel"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[20]; // \n            
  // <& pageelems.m3u_playlist_channel ...
  { 
#line 464 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 464 "multischedule.ecpp"
    _tnt_cq8.add( "channelId", (channel_IDs[channel]));
#line 464 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_channel"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[21]; // \n            </div></div> </div></td>\n\t       <td class="time spacer"> &nbsp; </td>\n
#line 467 "multischedule.ecpp"

                }

  reply.out() << _tntChunks[22]; // \t       </tr>\n
#line 471 "multischedule.ecpp"

                bool odd=true;
                std::list<SchedEntry>::iterator  cur_event[ MAX_CHANNELS ];
                for (int i=0;i<MAX_CHANNELS;i++)
                        cur_event[i]=table[i].begin();
                for (int row = 0 ; row < sched_end_row; row++ )
		{
                       int minutes= ( (sched_start +  row * 60 * MINUTES_PER_ROW ) % 3600 ) / 60;
                       std::string row_class;
                       if ( minutes < MINUTES_PER_ROW )
                       {
                         // full hour, swap odd/even
                         odd = !odd;
                       };
                       if (  (sched_start +  row * 60 * MINUTES_PER_ROW ) <= now &&
                             (sched_start +  (row+1) * 60 * MINUTES_PER_ROW ) > now )
                       {
                         row_class +=" current_row ";
                       }
                       row_class += odd ? " odd " : " even ";


  reply.out() << _tntChunks[23]; // \t\t       <tr>\n\t\t       <td class=" time leftcol rightcol 
#line 494 "multischedule.ecpp"
  reply.sout() << ( row_class );
  reply.out() << _tntChunks[24]; // ">\n
#line 495 "multischedule.ecpp"

			if (  minutes < MINUTES_PER_ROW )
			{

  reply.out() << _tntChunks[25]; // \t\t       
#line 499 "multischedule.ecpp"
  reply.sout() << ( cToSvDateTime( tr("%I:%M %p"), sched_start +  row * 60 * MINUTES_PER_ROW )  );
  reply.out() << _tntChunks[26]; // \n
#line 500 "multischedule.ecpp"

			}
			else
			{

  reply.out() << _tntChunks[27]; // \t\t\t &nbsp;\n
#line 506 "multischedule.ecpp"

		        }

  reply.out() << _tntChunks[28]; // \t\t       </td>\n
#line 510 "multischedule.ecpp"

                        for ( unsigned int channel = 0; channel< channel_names.size() ; channel++)
                        {
                                // output spacer column

  reply.out() << _tntChunks[29]; // \t\t                <td class = " time spacer " > &nbsp; </td>\n
#line 516 "multischedule.ecpp"

                                if ( cur_event[channel] == table[channel].end()
                                     || cur_event[channel]->start_row != row )
				{
                                  // no new event in this channel, skip it
					SchedEntry &en=*(--table[channel].end());
					if ( row == 0 || en.start_row + en.row_count == row) {

  reply.out() << _tntChunks[30]; // \t\t\t<td class="event topaligned leftcol rightcol" rowspan="
#line 524 "multischedule.ecpp"
  reply.sout() << ( sched_end_row - row );
  reply.out() << _tntChunks[31]; // ">\n                        <div class=" content1 " >\n                         <div class= "start withmargin">
#line 526 "multischedule.ecpp"
  if ( row == 0 )
    reply.sout() <<  "No EPG available" ;
#line 526 "multischedule.ecpp"
  if ( row != 0 )
    reply.sout() <<  "EPG end" ;
  reply.out() << _tntChunks[32]; // </div>\n                        </div>\n\t\t\t</td>\n
#line 529 "multischedule.ecpp"

					}
                                  continue;
				}

                                SchedEntry &en=*cur_event[channel];
                                if (en.title.empty() && en.start.empty() )
                                {
                                  // empty dummy event

  reply.out() << _tntChunks[33]; // \t\t\t<td class="event topaligned leftcol rightcol" rowspan="
#line 539 "multischedule.ecpp"
  reply.sout() << ( en.row_count );
  reply.out() << _tntChunks[34]; // ">\n                        <div class=" content1 " >\n                         <div class= "start withmargin">
#line 541 "multischedule.ecpp"
  if ( en.row_count == sched_end_row )
    reply.sout() <<  "EPG empty" ;
  reply.out() << _tntChunks[35]; // </div>\n                        </div>\n                        </td>\n
#line 544 "multischedule.ecpp"

				  ++cur_event[channel];
                                  continue;

                                }
                                  // output an event cell

  reply.out() << _tntChunks[36]; // \t\t\t<td class="event topaligned leftcol rightcol 
#line 551 "multischedule.ecpp"
  reply.sout() << ( en.has_timer ? "has_timer" : "" );
  reply.out() << _tntChunks[37]; // " rowspan="
#line 551 "multischedule.ecpp"
  reply.sout() << ( en.row_count );
  reply.out() << _tntChunks[38]; // ">\n                        <div class=" content1 " >\n                        <div class=" tools1 " >\n                          
  // <& pageelems.event_timer ...
  { 
#line 554 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 554 "multischedule.ecpp"
    _tnt_cq9.add( "epgid", (en.epgid));
#line 554 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "event_timer"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[39]; // \n
#line 555 "multischedule.ecpp"

                           if (LiveFeatures<features::epgsearch>().Recent() ) {

  reply.out() << _tntChunks[40]; //                           <a href="searchresults.html\?searchplain=
#line 558 "multischedule.ecpp"
  reply.sout() << ( StringUrlEncode(en.title) );
  reply.out() << _tntChunks[41]; // "><img src="
#line 558 "multischedule.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[42]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 558 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 558 "multischedule.ecpp"
    _tnt_cq10.add( "text", (tr("Search for repeats.")));
#line 558 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[43]; //  /></a>\n
#line 559 "multischedule.ecpp"

                           } else {
                             
  reply.out() << _tntChunks[44]; // <img src="img/transparent.png" width="16" height="16">
#line 561 "multischedule.ecpp"

                           }
			if (LiveSetup().GetShowIMDb() ) { 
  reply.out() << _tntChunks[45]; //                           
  // <& pageelems.imdb_info_href ...
  { 
#line 564 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 564 "multischedule.ecpp"
    _tnt_cq11.add( "title", (en.title));
#line 564 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[46]; // \n\t\t\t
#line 565 "multischedule.ecpp"
 } 
  reply.out() << _tntChunks[47]; //                          </div><div class= "start withmargin">
#line 566 "multischedule.ecpp"
  reply.sout() << ( en.start );
  reply.out() << _tntChunks[48]; // </div>\n\t\t\t  <div class="title withmargin"><a 
  // <& tooltip.hint ...
  { 
#line 567 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 567 "multischedule.ecpp"
    _tnt_cq12.add( "text", (StringEscapeAndBreak(tr("Click to view details."))));
#line 567 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq12);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 567 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 567 "multischedule.ecpp"
    _tnt_cq13.add( "domId", en.epgid);
#line 567 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[49]; // >
#line 567 "multischedule.ecpp"
  reply.sout() << ( en.title );
  reply.out() << _tntChunks[50]; // </a></div>\n
#line 568 "multischedule.ecpp"

                         if ( en.row_count>2 && !en.short_description.empty() )
                         {

  reply.out() << _tntChunks[51]; //                           <div class="short withmargin">
#line 572 "multischedule.ecpp"
  reply.sout() << ( en.short_description.empty() ? "&nbsp;" : en.short_description );
  reply.out() << _tntChunks[52]; // </div>\n
#line 573 "multischedule.ecpp"

                         }
                         if ( en.row_count>3 && ! en.description_trunc.empty() )
                         {

  reply.out() << _tntChunks[53]; //                           <div class="description withmargin">
#line 578 "multischedule.ecpp"
  reply.sout() << (en.description_trunc);
  reply.out() << _tntChunks[54]; // ...\n
#line 579 "multischedule.ecpp"

                           if ( en.truncated )
                           {

  reply.out() << _tntChunks[55]; //                            <a 
  // <& tooltip.hint ...
  { 
#line 583 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 583 "multischedule.ecpp"
    _tnt_cq14.add( "text", (StringEscapeAndBreak(tr("Click to view details."))));
#line 583 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq14);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 583 "multischedule.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 583 "multischedule.ecpp"
    _tnt_cq15.add( "domId", en.epgid);
#line 583 "multischedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[56]; // > 
#line 583 "multischedule.ecpp"
  reply.sout() << ( tr("more") );
  reply.out() << _tntChunks[57]; // </a>\n
#line 584 "multischedule.ecpp"

                           }

  reply.out() << _tntChunks[58]; //                            </div>\n
#line 588 "multischedule.ecpp"

                         }

  reply.out() << _tntChunks[59]; //                           </div></div>\n                          </td>\n
#line 593 "multischedule.ecpp"

                          // move to next event for this channel
                          ++cur_event[channel];
                        }

  reply.out() << _tntChunks[60]; // \t\t       </tr>\n
#line 599 "multischedule.ecpp"

		}

  reply.out() << _tntChunks[61]; // \t\t\t<tr>\n
#line 603 "multischedule.ecpp"

			for ( unsigned int channel = 0; channel <= channel_names.size() ; channel++)
			{

  reply.out() << _tntChunks[62]; // \t\t\t<td class = " event leftcol rightcol bottomrow " > &nbsp; </td>\n\t\t\t<td class = " time spacer " > &nbsp; </td>\n
#line 609 "multischedule.ecpp"

			}

  reply.out() << _tntChunks[63]; // \t\t\t</tr>\n\t\t\t</table>\n\t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[64]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[65]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::channel_selection_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("multischedule::channel_selection " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 47 "multischedule.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 50 "multischedule.ecpp"
  typedef unsigned int channel_group_type;
  TNT_REQUEST_SHARED_VAR(unsigned int, channel_group, (0));   // <%request> unsigned int channel_group(0)
  _tnt_ignore_unused<channel_group_type>(channel_group);
#line 51 "multischedule.ecpp"
  typedef unsigned int time_selected_type;
  TNT_REQUEST_SHARED_VAR(unsigned int, time_selected, (0));   // <%request> unsigned int time_selected(0)
  _tnt_ignore_unused<time_selected_type>(time_selected);
#line 52 "multischedule.ecpp"
  typedef cString prev_type;
  TNT_REQUEST_SHARED_VAR(cString, prev, ());   // <%request> cString prev
  _tnt_ignore_unused<prev_type>(prev);
#line 53 "multischedule.ecpp"
  typedef cString next_type;
  TNT_REQUEST_SHARED_VAR(cString, next, ());   // <%request> cString next
  _tnt_ignore_unused<next_type>(next);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[66]; // <form action="multischedule.html" method="get" id="channels">\n   <span>\n     <label for="channel">
#line 622 "multischedule.ecpp"
  reply.sout() << ( tr("Channel") );
  reply.out() << _tntChunks[67]; // :&nbsp;<span class="bold"></span></label>\n     <select name="channel" id="channel"  onchange="document.forms.channels.submit()" >\n
#line 624 "multischedule.ecpp"
	for ( unsigned int i = 0; i < channel_groups_names.size(); ++i ) {

#line 625 "multischedule.ecpp"


  reply.out() << _tntChunks[68]; // \t\t<option value="
#line 626 "multischedule.ecpp"
  reply.sout() << ( i );
  reply.out() << _tntChunks[69]; // "\n
#line 627 "multischedule.ecpp"
                      if ( i == channel_group )

#line 628 "multischedule.ecpp"
                      {

  reply.out() << _tntChunks[70]; // \t\t\tselected="selected"\n
#line 630 "multischedule.ecpp"
                      }

  reply.out() << _tntChunks[71]; //                         >
#line 631 "multischedule.ecpp"
  reply.sout() << ( channel_groups_names[i] );
  reply.out() << _tntChunks[72]; // </option>\n
#line 632 "multischedule.ecpp"
	}

  reply.out() << _tntChunks[73]; //      </select>\n     <label for="time_para">
#line 634 "multischedule.ecpp"
  reply.sout() << ( tr("Time") );
  reply.out() << _tntChunks[74]; // :&nbsp;<span class="bold"></span></label>\n     <select name="time_para" id="time_para"  onchange="document.forms.channels.submit()" >\n
#line 636 "multischedule.ecpp"
	for ( unsigned int i = 0; i < times_names.size(); ++i ) {

#line 637 "multischedule.ecpp"


  reply.out() << _tntChunks[75]; // \t\t<option value="
#line 638 "multischedule.ecpp"
  reply.sout() << ( i );
  reply.out() << _tntChunks[76]; // "\n
#line 639 "multischedule.ecpp"
                      if ( i == time_selected )

#line 640 "multischedule.ecpp"
                      {

  reply.out() << _tntChunks[77]; // \t\t\tselected="selected"\n
#line 642 "multischedule.ecpp"
                      }

  reply.out() << _tntChunks[78]; //                         >
#line 643 "multischedule.ecpp"
  reply.sout() << ( times_names[i] );
  reply.out() << _tntChunks[79]; // </option>\n
#line 644 "multischedule.ecpp"
	}

  reply.out() << _tntChunks[80]; //      </select>\n   </span>\n</form>\n<span class="sep">|</span>\n
#line 649 "multischedule.ecpp"
  if ( *prev )
    reply.out() <<  "<a " << *prev << ">";
  reply.out() << _tntChunks[81]; // \302\253 Prev
#line 649 "multischedule.ecpp"
  if ( *prev )
    reply.out() <<  "</a>" ;
  reply.out() << _tntChunks[82]; // \n<span class="sep">|</span>\n
#line 651 "multischedule.ecpp"
  if ( *next )
    reply.out() <<  "<a " << *next << ">";
  reply.out() << _tntChunks[83]; // Next \302\273
#line 651 "multischedule.ecpp"
  if ( *next )
    reply.out() <<  "</a>" ;
  reply.out() << _tntChunks[84]; // \n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
