////////////////////////////////////////////////////////////////////////
// playlist.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.playlist")

// <%pre>
#line 1 "playlist.ecpp"


#include <setup.h>
#include <tools.h>
#include <users.h>
#include <recman.h>

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class m3u_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        m3u_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    m3u_type m3u;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("playlist");

static const char* rawData = "\024\000\000\000\025\000\000\000\026\000\000\000\027\000\000\000\030\000\000\000\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    m3u(*this, "m3u")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("playlist " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string channel_str = qparam.get< std::string >("channel_str");
std::string recid = qparam.get< std::string >("recid");
  // </%args>

#line 16 "playlist.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 19 "playlist.ecpp"
  typedef cChannel* Channel_type;
  TNT_REQUEST_PAGE_VAR(cChannel*, Channel, ());   // <%request> cChannel* Channel
  _tnt_ignore_unused<Channel_type>(Channel);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 22 "playlist.ecpp"

	tChannelID channel = tChannelID::FromString(channel_str.c_str());

	if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");
	if (!cUser::CurrentUserHasRightTo(UR_STARTREPLAY))
		throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );

    // the availabilty of Channel signals that we will do live tv streaming.
	Channel = 0;
	if (recid.empty()) {
		LOCK_CHANNELS_READ;
		Channel = (cChannel *)Channels->GetByChannelID(channel);
		if (Channel == 0) {
			throw HtmlError( tr("Couldn't find channel or no channels available. Maybe you mistyped your request?") );
		}
	}
	std::string server = request.getHost();
	server = server.substr(0, server.rfind(':'));
	std::string videourl;
	reply.setContentType("audio/x-mpegurl");
	if (Channel != 0) {
		std::string channelname = Channel->Name();
		int streamdevPort = LiveSetup().GetStreamdevPort();
		videourl = concat("#EXTM3U\n#EXTINF:-1,", channelname, "\nhttp://", server, ":", cToSvInt(streamdevPort), "/", LiveSetup().GetStreamdevType(), "/", *Channel->GetChannelID().ToString());
	}
	else {
    cToSvConcat rfid;
    if (LiveSetup().GetUseStreamdev() ) {
      const cRecording* recording = LiveRecordingsManager()->GetByMd5Hash(recid);
      if (recording) {
        struct stat st;
        if (stat(recording->FileName(), &st) == 0)
          rfid.appendFormated("%lu:%llu.rec", (unsigned long) st.st_dev, (unsigned long long) st.st_ino);
      }
    }

    if (rfid.empty()) 
      videourl = concat("#EXTM3U\n#EXTINF:-1\nhttp://", server, ":", cToSvInt(LiveSetup().GetServerPort()), "/recstream.html?recid=", recid);
    else
      videourl = concat("#EXTM3U\n#EXTINF:-1\nhttp://", server, ":", cToSvInt(LiveSetup().GetStreamdevPort()), "/", rfid, ".ts");
	}

  // <& playlist.m3u ...
  { 
#line 64 "playlist.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 64 "playlist.ecpp"
    _tnt_cq0.add( "videourl", (videourl));
#line 64 "playlist.ecpp"
    callComp(tnt::Subcompident(std::string(), "playlist", "m3u"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[0]; // \n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[1]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[2]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::m3u_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("playlist::m3u " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string videourl = qparam.get< std::string >("videourl");
  // </%args>

#line 19 "playlist.ecpp"
  typedef cChannel* Channel_type;
  TNT_REQUEST_PAGE_VAR(cChannel*, Channel, ());   // <%request> cChannel* Channel
  _tnt_ignore_unused<Channel_type>(Channel);
#line 16 "playlist.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 71 "playlist.ecpp"
  reply.sout() << ( videourl );
  reply.out() << _tntChunks[3]; // \n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
