////////////////////////////////////////////////////////////////////////
// recordings.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.recordings")

// <%pre>
#line 1 "recordings.ecpp"


#include <string>
#include <string_view>
#include <setup.h>
#include <tasks.h>
#include <tools.h>
#include <users.h>
#include <recman.h>
#include <tntconfig.h>
#include <vdr/channels.h>
#include <stringhelpers.h>

#ifdef HAVE_PCRE2
#include <StringMatch.h>
#endif
#include <vdr/videodir.h>

#define MB_PER_MINUTE 25.75 // this is just an estimate!

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class recordings_item_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        recordings_item_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class sort_options_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        sort_options_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class setactive_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        setactive_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class del_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        del_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class edit_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        edit_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class todel_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        todel_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class rec_tools_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        rec_tools_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class archived_disc_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        archived_disc_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class delete_error_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        delete_error_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    recordings_item_type recordings_item;
    sort_options_type sort_options;
    setactive_type setactive;
    del_rec_type del_rec;
    edit_rec_type edit_rec;
    todel_type todel;
    rec_tools_type rec_tools;
    archived_disc_type archived_disc;
    delete_error_type delete_error;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("recordings");

static const char* rawData = "`\003\000\000a\003\000\000b\003\000\000c\003\000\000\325\003\000\000\342\003\000\000\347"
  "\003\000\000\354\003\000\000\031\004\000\000<\004\000\000Y\004\000\000\034\005\000\000$\005\000\000*\005\000\000<\005"
  "\000\000y\005\000\000\237\005\000\000\342\007\000\000k\010\000\000\341\010\000\000P\t\000\000g\t\000\000\373\n\000"
  "\000h\015\000\000l\015\000\000p\015\000\000t\015\000\000x\015\000\000{\015\000\000\032\016\000\000p\016\000\000s\016"
  "\000\000\277\016\000\000\334\016\000\000\376\016\000\000K\017\000\000\227\017\000\000\232\017\000\000\307\017\000\000"
  "\017\021\000\000\034\021\000\000(\021\000\000;\021\000\000\350\021\000\000\351\021\000\000\353\021\000\000\354\021"
  "\000\000\356\021\000\000\357\021\000\000+\022\000\000>\022\000\000D\022\000\000E\022\000\000\013\023\000\000W\023\000"
  "\000\210\023\000\000\267\023\000\000\362\023\000\000L\024\000\000V\024\000\000t\024\000\000\215\024\000\000\216\024"
  "\000\000\217\024\000\000\221\024\000\000\363\024\000\000\026\025\000\000k\025\000\000\234\025\000\000\352\025\000\000"
  "H\026\000\000n\026\000\000\331\026\000\000\364\026\000\0000\027\000\000X\027\000\000e\027\000\000\245\027\000\000\340"
  "\027\000\000\001\030\000\000\014\030\000\000\021\030\000\000\024\030\000\000\026\030\000\000\"\030\000\000C\030\000"
  "\000[\030\000\000j\030\000\000\215\030\000\000\217\030\000\000\223\030\000\000\231\030\000\000\255\030\000\000\263"
  "\030\000\000\265\030\000\000\271\030\000\000\275\030\000\000\321\030\000\000\342\030\000\000\347\030\000\000\352\030"
  "\000\000\354\030\000\000\374\030\000\000^\031\000\000\274\031\000\000\032\032\000\000n\032\000\000\260\032\000\000"
  "\016\033\000\000\034\033\000\000T\033\000\000U\033\000\000V\033\000\000o\033\000\000\226\033\000\000\236\033\000\000"
  "\244\033\000\000\246\033\000\000\250\033\000\000\346\033\000\000\356\033\000\000\364\033\000\000\366\033\000\000\370"
  "\033\000\000H\034\000\000N\034\000\000P\034\000\000R\034\000\000W\034\000\000\220\034\000\000\230\034\000\000\236\034"
  "\000\000\240\034\000\000\241\034\000\000\246\034\000\000\332\034\000\000\t\035\000\0009\035\000\000=\035\000\000I\035"
  "\000\000Q\035\000\000\214\035\000\000\225\035\000\000\272\035\000\000\303\035\000\000\306\035\000\000\315\035\000\000"
  "\316\035\000\000\317\035\000\000\335\035\000\000\336\035\000\000\337\035\000\000\377\035\000\000\005\036\000\000\015"
  "\036\000\000\023\036\000\000%\036\000\000'\036\000\0002\036\000\000A\036\000\000B\036\000\000C\036\000\000f\036\000"
  "\000l\036\000\000t\036\000\000z\036\000\000\214\036\000\000\230\036\000\000\241\036\000\000\250\036\000\000\251\036"
  "\000\000\252\036\000\000\334\036\000\000\363\036\000\000\030\037\000\000h\037\000\000\323\037\000\000\025 \000\000"
  "\224 \000\000\246 \000\000\350 \000\000 !\000\000#!\000\000&!\000\000]!\000\000\353!\000\000\034\"\000\000\134\"\000"
  "\000_\"\000\000\222\"\000\000\224\"\000\000\225\"\000\000\226\"\000\000\227\"\000\000\230\"\000\000\231\"\000\000\232"
  "\"\000\000\337\"\000\000!#\000\000$#\000\000&#\000\000)#\000\000-#\000\0001#\000\0004#\000\0007#\000\000D#\000\000E#"
  "\000\000F#\000\000P#\000\000_#\000\000c#\000\000d#\000\000e#\000\000f#\000\000g#\000\000\n\n\n\n<html>\n  <head>\n   "
  " <meta name=\"viewport\" content=\"width=device-width, initial-scale=1\" />\n    <title>VDR-Live - </title>\n    \n  "
  "  \n    \n<script>\nconst recs = [];\nconst vdr_start = ;\nconst recordings_tree_creation = ;\nconst param_name_recs "
  "= '&r=';\nconst rec_ids = Object.create(null)\nrec_ids[\"T\"] = [1, 2]\n\nfunction RecordingActionS(s, id, A, Img, Ti"
  "tle) {\n  s.a += '<a href=\"'\n  s.a += A\n  s.a += 'recording_'\n  s.a += id\n  s.a += '&sort=&filter=&flat=&history"
  "_num_back=\" title=\"'\n  s.a += Title\n  s.a += '\"><img class=\"icon\" src=\"'\n  s.a += Img\n  s.a += '\" /></a>'"
  "\n}\n\n\nfunction RecordingsSt_int(s, level, displayFolder, data) {\n  s.a += '<li class=\"recording\"><div>'\n  s.a "
  "+= '<table width=\"100%\" class=\"recordings\">'\n  for (obj_i of data) {\n    if (typeof recs[obj_i] === 'undefined'"
  ") continue;\n    obj = recs[obj_i]\n    s.a += '<tr class=\"recording_item\">'\n    if (level > 0) s.a += \n      '<t"
  "d class=\"space\"> <img src=\"img/transparent.png\" width=\"' + String(16 * level) + 'px\" height=\"16px\" /></td>'\n"
  "    s.a += '<td class=\"td-hidden-xs\"><div class=\"hidden-xs recording_imgs\">'\n    if (obj[1].length != 0) {\n    "
  "  s.a += '<img class=\"icon\" src=\"on_dvd.png\" alt=\"on_dvd\" title=\"'\n      s.a += obj[1]\n      s.a += '/>'\n  "
  "  } else {\n      s.a += '<input type=\"checkbox\" name=\"deletions\" value=\"recording_'\n      s.a += obj[0]\n     "
  " s.a += '\" />'\n    }\n    s.a += '</div></td>'  // end of recording_imgs\n    s.a += '<td class=\"space\">'\n      "
  "addScraperImageTitle(s, obj[3], obj[4], obj[5], obj[6], obj[7], obj[8], '');\n    s.a += '</td>'\n    s.a += '<td cla"
  "ss=\"td-hidden-xs\"><div class=\"hidden-xs recording_day margin-bottom\">'\n    s.a += obj[9]\n    s.a += '</div><div"
  " class=\"hidden-xs recording_channel\">'\n    s.a += obj[12]\n    s.a += '</div></td><td class=\"td-hidden-xs\" style"
  "=\"text-align:right\"><div class=\"hidden-xs recording_duration margin-bottom\">'\n    s.a += obj[19]\n    if (obj[17"
  "] > 0) {\n      s.a += '<span title=\"'\n      s.a += ''\n      s.a += '\"> ['\n      addTime(s, obj[17])\n      s.a "
  "+= ']'\n      s.a += '</span>'\n    }\n    s.a += '</div><div class=\"hidden-xs recording_size\">'\n    s.a += obj[20"
  "]\n    s.a += '</div></td><td>'\n    addErrorIcon(s, obj[10], obj[17], obj[19], obj[21])\n    addHdSdIcon(s, obj[11],"
  " obj[12], obj[22])\n    s.a += '</td>'  // end column with error / sd/hd image\n    s.a += '<td><div class=\"recordin"
  "g_name'\n    s.a += obj[13]\n    s.a += '\">'\n    if (displayFolder == 1) folder = obj[18]\n    else folder = ''\n  "
  "  s.a += '<div class=\"withmargin\">'\n    addEventRec(s, 'recording_', obj[0], obj[14], folder, obj[15], obj[16], ''"
  ", '', '', '', '', );\n    s.a += '</div></div></td>'  // end if recording_name / short description\n    s.a += '<td><"
  "div class=\"recording_actions\">'\n    if (obj[1].length == 0) {\n        RecordingActionS(s, obj[0], \"vdr_request/p"
  "lay_recording\?param=\", \"play.png\", \"\")\n        RecordingActionS(s, obj[0], \"playlist.m3u\?recid=\", \"playlis"
  "t.png\", \"\134\" download=\134\"playlist.m3u\")\n        IMDBS(s, obj[2], obj[14])\n      RecordingActionS(s, obj[0]"
  ", \"edit_recording.html\?recid=\", \"edit.png\", \"\")\n      RecordingActionS(s, obj[0], \"epginfo.html\?epgid=del_"
  "\", \"del.png\", \"\")\n    } else {\n      IMDBS(s, obj[2], obj[14])\n    }\n    s.a += '</div>'\n    if (obj[1].len"
  "gth != 0) {\n      s.a += '<div class=\"recording_arch\">'\n      s.a += obj[1]\n      s.a += '</div>'\n    }\n    s."
  "a += '</td></tr>'\n  }\n  s.a += '</table></div></li>'\n}\n\n</script>\n\n  <script type=\"text/javascript\" src=\"js"
  "/live/treeview.js\"></script>\n  <script>\n  const tv = new Treeview(\"minus.png\", \"plus.png\", \"folder_open.png\""
  ", \"folder_closed.png\");\n  </script>\n</head>\n<body onload=\"adjustHeader()\" onresize=\"adjustHeader()\" onpagesh"
  "ow=\"clearCheckboxes(document.getElementById('form_recordings'))\">\n  \n  \n  \n  <div class=\"inhalt\">\n    <div c"
  "lass=\"boxheader\"><div><div></div></div></div>\n      \n      <form method=\"post\" name=\"recordings\" id=\"form_re"
  "cordings\" action=\"recordings.ecpp\">\n        <div class=\"recordings\">\n          <ul class=\"recordingslist\" st"
  "yle=\"display: block;\">\n            \n          </ul>\n        </div>\n\t\t\t\t<input type=\"hidden\" name=\"sort\""
  " value=\"\">\n\t\t\t\t<input type=\"hidden\" name=\"filter\" value=\"\">\n\t\t\t\t<input type=\"hidden\" name=\"flat"
  "\" value=\"\">\n\t\t\t\t<input type=\"hidden\" name=\"history_num_back\" value=\"\">\n        <div class=\"withmargin"
  " hidden-xs\">\n          <button class=\"red\" type=\"submit\"></button>\n\n        </div>\n      </form>\n  </div>\n"
  "</body>\n</html>\n\n\n\n\n      <li class=\"recording\">\n        <div class=\"recording_item\" onclick = \"tv.Toggle"
  "(this, 'fldr_')\">\n        <table><tr>\n                      <td class = \"space\">\n              <img src=\"img/t"
  "ransparent.png\" width=\"px\" height=\"16px\" />\n            </td>\n                    <td class=\"space\">\n      "
  "      <img class=\"recording_expander\" src=\"plus.png\" />\n          </td><td class=\"space\">\n            <img cl"
  "ass=\"recording_folder\" src=\"folder_closed.png\" />\n          </td>\n            <td class = space>\n             "
  " <div class=\"thumb\">\n                <img data-src=\"/tvscraper/\"\n                  class=\"\"\n                "
  "/>\n              </div>\n            </td>\n        <td class=\"recording_folder_name\">\n          \n        </td><"
  "/tr></table>\n        </div>\n        <ul id=\"fldr_\" class=\"recordingslist\" style=\"display: none;\">\n          "
  "\n        </ul>\n      </li>\n      <script>\n  recs[]=[]\n</script>\n      <script>\n      rec_ids[\"fldr_\"] = []\n"
  "    </script>\n        <script>\n      document.write(rec_string_d([, , [  ]]))\n      rec_ids[\"fldr_\"] = [, , [  ]"
  "]\n      </script>\n    <script>\n        recs[]=[]\n</script>\n            <li class=\"recording\">\n        <div cl"
  "ass=\"recording_item\" onclick = \"tv.Toggle(this, 'fldr_')\">\n          <table><tr><td class=\"space\">\n          "
  "  <img class=\"recording_expander\" src=\"plus.png\" />\n          </td><td class=\"space\">\n            <img class="
  "\"recording_folder\" src=\"folder_closed.png\" />\n          </td><td class=\"recording_folder_name\">\n            "
  "\n          </td></tr></table>\n        </div>\n        <ul id=\"fldr_\" class=\"recordingslist\" style=\"display: no"
  "ne;\">\n          <script>\n            rec_ids[\"fldr_\"] = [1, 1, [  ]]\n          </script>\n        </ul>\n      "
  "</li>\n      \n\n<span class=\"label bold\"> </span>\n<a href=\"recordings.html\?sort=&filter=&flat=\"  ></a>\n<span "
  "class=\"sep\">|</span>\n<a href=\"recordings.html\?sort=&filter=&flat=\"  ></a>\n<span class=\"sep\">|</span>\n<a hre"
  "f=\"recordings.html\?sort=duplicates&filter=&flat=\"  ></a>\n<span class=\"sep\">|</span>\n<a href=\"recordings.html"
  "\?sort=&filter=&flat=\" ></a>\n<span class=\"sep\">|</span>\n<span class=\"label bold\">:&nbsp;<input type=\"text\" n"
  "ame=\"filter\" value=\"\" id=\"filter\" onchange=\"filterRecordings(this, '', '')\" />&nbsp;</span>\n<span class=\"se"
  "p\">|</span>\n<img onclick=\"ExpandAll()\" src=\"\" alt=\"\" />\n<img onclick=\"CollapseAll()\" src=\"\" alt=\"\" />"
  "\n<br />\n\n\nclass=\"active\"\n\n<a href=\"epginfo.html\?epgid=del_&sort=&filter=&flat=&history_num_back=\" ><img sr"
  "c=\"\" alt=\"\" /></a>\n\n<a href=\"edit_recording.html\?recid=&sort=&filter=&flat=&history_num_back=\"><img src=\"\""
  " alt=\"\"  /></a>\n\n<!DOCTYPE html>\n<html>\n  <script>\n    history.go(-);\n  </script>\n</html>\n<div class=\"epg_"
  "description\" id=\"del_\">\n  <div class=\"station\">\n    <div class=\"boxheader\"><div><div class=\"caption\"></div"
  "></div></div>\n  </div>\n  <div class=\"epg_content\">\n    <form>\n      <div class=\"about_head\"><div><div></div><"
  "/div></div>\n      <input type=\"hidden\" name=\"epgid\" value=\"\" >\n      <input type=\"hidden\" name=\"delete_rec"
  "\" value=\"confirmed\" >\n      <input type=\"hidden\" name=\"history_num_back\" value=\"\" id=\"history_del_\">\n   "
  "   <div class=\"about_left\">\n        <button id=\"confirm_del_\" class=\"green\" type=\"button\" onclick=\"delete_r"
  "ec_back('', )\"></button>\n      </div>\n      <div class=\"about_right\">\n\n<script>\nfunction cancel_delete() {\n "
  " if (document.referrer.indexOf(\"epginfo.html\?\") != -1) {\n    history.go(-1);\n  } else {\n    history.go(-);\n  }"
  "\n}\n</script>\n        <button id=\"close_del_\" type=\"button\" class=\"red\" onclick=\"back_depending_referrer(1, "
  ")\"></button>\n      </div>\n    </form>\n  </div>\n</div>\n\n\n\n\n\n\n\n\n<img data-src=\"img/transparent.png\" hei"
  "ght=\"10px\" />\n<span id=\"icons-\"></span>\n<script class=\"injectIcons\">\ninjectErrorHdSdIcon(\"icons-\", , , \""
  "\", \"\", \"\", , \"\")\n</script>\n\n\n<img src=\"\" alt=\"on_dvd\"  />\n\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    recordings_item(*this, "recordings_item"),
    sort_options(*this, "sort_options"),
    setactive(*this, "setactive"),
    del_rec(*this, "del_rec"),
    edit_rec(*this, "edit_rec"),
    todel(*this, "todel"),
    rec_tools(*this, "rec_tools"),
    archived_disc(*this, "archived_disc"),
    delete_error(*this, "delete_error")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string sort = qparam.get< std::string >("sort");
std::string todel = qparam.get< std::string >("todel");
std::string diskinfo = qparam.get< std::string >("diskinfo");
std::string filter = qparam.get< std::string >("filter");
std::vector< std::string > deletions = qparam.getvector< std::string >("deletions");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 34 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 39 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 40 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 41 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 42 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n
  reply.out() << _tntChunks[2]; // \n
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 46 "recordings.ecpp"

std::chrono::time_point<std::chrono::high_resolution_clock> timeStart = std::chrono::high_resolution_clock::now();

reply.setHeader (tnt::httpheader::cacheControl, "no-store, no-cache, max-age=0, must-revalidate, proxy-revalidate", true);
if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

if (request.getMethod() != "POST") history_num_back = 0;  // we can go back in history to this page
else ++history_num_back;  // we have to go back in history to a prev page, to avoid re-send of form data

// create the "current" values of the global request parameters, based on their old values and the current arguments
// basically, this is a bad idea. Pushing "refresh" changes the sort order :( .
// Better: Urls on menue have parameters depending on the current sort option
if (! flat.empty() ) currentFlat = flat;
// sort depends on old sort, and sort parameter
currentSort = LiveSetup().GetLastSortingMode();
if (currentSort.empty() ) currentFlat == "true"?currentSort = "errorsts":currentSort = "datedesc";
if (!sort.empty()) {
  if (sort == "date")
    currentSort = (currentSort == "datedesc") ? "dateasc" : "datedesc";
  else if (sort == "datedesc" || sort == "dateasc") currentSort = sort;
  else if (sort == "name")
    currentSort = (currentSort == "nameasc") ? "namedesc" : "nameasc";
  else if (sort == "nameasc" || sort == "namedesc") currentSort = sort;
  else if (sort == "errors")
    currentSort = (currentSort == "errorsts") ? "errorsdur" : "errorsts";
  else if (sort == "errorsts" || sort == "errorsdur") currentSort = sort;
  else if (sort == "duplicates")
    currentSort = sort;
  LiveSetup().SetLastSortingMode(currentSort);
}
currentFilter = filter;

pageTitle = tr("Recordings");

deleteResult = "";
if (!todel.empty()) {
  if (!cUser::CurrentUserHasRightTo(UR_DELRECS))
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
  deletions.push_back(todel);
}
for (auto it = deletions.begin(); it != deletions.end(); ++it) {
  if (cUser::CurrentUserHasRightTo(UR_DELRECS)) {
    RemoveRecordingTask task(*it);
    LiveTaskManager().Execute(task);
/*
    if (!task.Result())
    deleteResult += std::string() + tr("ERROR:") + " " + task.Error() + "<br/>";
    else
*/
    if (task.Result())
      deleteResult += std::string() + tr("Deleted recording:") + " " + StringReplace(task.RecName(), "~", "/") + "<br/>";
  }
  else {
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
  }
}
deletions.clear();

int FreeMB, UsedMB;
int Percent = cVideoDirectory::VideoDiskSpace(&FreeMB, &UsedMB);
int Minutes = int(double(FreeMB) / MB_PER_MINUTE);
int Hours = Minutes / 60;
Minutes %= 60;
diskinfo = cString::sprintf("%s %d%%  -  %2d:%02d %s", trVDR("Disk"), Percent, Hours, Minutes, trVDR("free"));
#if TNTVERSION >= 30000
const char *TNT_ARRAY = "[]";
#else
const char *TNT_ARRAY = "";
#endif
const char *lf = "<br/>";


RecordingsTreePtr recordingsTree(LiveRecordingsManager()->GetRecordingsTree());

// get data for all open nodes
std::vector<int> available_recs;
std::string openTreeNodes;
if (request.hasCookie("VDR-Live-Recordings-Tree-Open-Nodes")) {
  openTreeNodes = request.getCookie("VDR-Live-Recordings-Tree-Open-Nodes");
//  isyslog("live: VDR-Live-Recordings-Tree-Open-Nodes = %s", openTreeNodes.c_str());
}
cToSvConcat<0> recoring_item;
recoring_item.reserve(25000);


  // <& pageelems.doc_type ...
  { 
#line 131 "recordings.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 131 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n<html>\n  <head>\n    <meta name="viewport" content="width=device-width, initial-scale=1" />\n    <title>VDR-Live - 
#line 135 "recordings.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[4]; // </title>\n    
  // <& pageelems.stylesheets ...
  { 
#line 136 "recordings.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 136 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n    
  // <& pageelems.create_html_js ...
  { 
#line 137 "recordings.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 137 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "create_html_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[6]; // \n    
  // <& pageelems.ajax_js ...
  { 
#line 138 "recordings.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 138 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[7]; // \n<script>\nconst recs = [];\nconst vdr_start = 
#line 141 "recordings.ecpp"
  reply.sout() << ( cSv(cToSvInt(LiveSetup().GetVdrStart() )) );
  reply.out() << _tntChunks[8]; // ;\nconst recordings_tree_creation = 
#line 142 "recordings.ecpp"
  reply.sout() << ( cSv(cToSvInt(recordingsTree->getCreationTimestamp() )) );
  reply.out() << _tntChunks[9]; // ;\nconst param_name_recs = '&r
#line 143 "recordings.ecpp"
  reply.sout() << ( TNT_ARRAY );
  reply.out() << _tntChunks[10]; // =';\nconst rec_ids = Object.create(null)\nrec_ids["T"] = [1, 2]\n\nfunction RecordingActionS(s, id, A, Img, Title) {\n  s.a += '<a href="'\n  s.a += A\n  s.a += 'recording_'\n  s.a += id\n  s.a += '&sort=
#line 152 "recordings.ecpp"
  reply.sout() << (currentSort);
  reply.out() << _tntChunks[11]; // &filter=
#line 152 "recordings.ecpp"
  reply.sout() << (currentFilter);
  reply.out() << _tntChunks[12]; // &flat=
#line 152 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[13]; // &history_num_back=
#line 152 "recordings.ecpp"
  reply.sout() << (history_num_back+1);
  reply.out() << _tntChunks[14]; // " title="'\n  s.a += Title\n  s.a += '"><img class="icon" src="
#line 154 "recordings.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[15]; // '\n  s.a += Img\n  s.a += '" /></a>'\n}\n\n
  reply.out() << _tntChunks[16]; // \nfunction RecordingsSt_int(s, level, displayFolder, data) {\n  s.a += '<li class="recording"><div>'\n  s.a += '<table width="100%" class="recordings">'\n  for (obj_i of data) {\n    if (typeof recs[obj_i] === 'undefined') continue;\n    obj = recs[obj_i]\n    s.a += '<tr class="recording_item">'\n    if (level > 0) s.a += \n      '<td class="space"> <img src="img/transparent.png" width="' + String(16 * level) + 'px" height="16px" /></td>'\n    s.a += '<td class="td-hidden-xs"><div class="hidden-xs recording_imgs">'\n    if (obj[1].length != 0) {\n      s.a += '<img class="icon" src="
#line 198 "recordings.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[17]; // on_dvd.png" alt="on_dvd" title="'\n      s.a += obj[1]\n      s.a += '/>'\n    } else {\n      s.a += '<input type="checkbox" name="deletions
#line 202 "recordings.ecpp"
  reply.sout() << (TNT_ARRAY);
  reply.out() << _tntChunks[18]; // " value="recording_'\n      s.a += obj[0]\n      s.a += '" />'\n    }\n    s.a += '</div></td>'  // end of recording_imgs\n
#line 207 "recordings.ecpp"
   if (!LiveSetup().GetTvscraperImageDir().empty() ) {

  reply.out() << _tntChunks[19]; //     s.a += '<td class="space">'\n      addScraperImageTitle(s, obj[3], obj[4], obj[5], obj[6], obj[7], obj[8], '
#line 209 "recordings.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[20]; // ');\n    s.a += '</td>'\n
#line 211 "recordings.ecpp"
   }

  reply.out() << _tntChunks[21]; //     s.a += '<td class="td-hidden-xs"><div class="hidden-xs recording_day margin-bottom">'\n    s.a += obj[9]\n    s.a += '</div><div class="hidden-xs recording_channel">'\n    s.a += obj[12]\n    s.a += '</div></td><td class="td-hidden-xs" style="text-align:right"><div class="hidden-xs recording_duration margin-bottom">'\n    s.a += obj[19]\n    if (obj[17] > 0) {\n      s.a += '<span title="'\n      s.a += '
#line 220 "recordings.ecpp"
  reply.sout() << (tr("Duration deviation from event length"));
  reply.out() << _tntChunks[22]; // '\n      s.a += '"> ['\n      addTime(s, obj[17])\n      s.a += ']'\n      s.a += '</span>'\n    }\n    s.a += '</div><div class="hidden-xs recording_size">'\n    s.a += obj[20]\n    s.a += '</div></td><td>'\n    addErrorIcon(s, obj[10], obj[17], obj[19], obj[21])\n    addHdSdIcon(s, obj[11], obj[12], obj[22])\n    s.a += '</td>'  // end column with error / sd/hd image\n    s.a += '<td><div class="recording_name'\n    s.a += obj[13]\n    s.a += '">'\n    if (displayFolder == 1) folder = obj[18]\n    else folder = ''\n    s.a += '<div class="withmargin">'\n    addEventRec(s, 'recording_', obj[0], obj[14], folder, obj[15], obj[16], '
#line 238 "recordings.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[23]; // ', '
#line 238 "recordings.ecpp"
  reply.sout() << (tr("Click to view details."));
  reply.out() << _tntChunks[24]; // ', '
#line 238 "recordings.ecpp"
  reply.sout() << ( sort );
  reply.out() << _tntChunks[25]; // ', '
#line 238 "recordings.ecpp"
  reply.sout() << ( filter );
  reply.out() << _tntChunks[26]; // ', '
#line 238 "recordings.ecpp"
  reply.sout() << ( flat );
  reply.out() << _tntChunks[27]; // ', 
#line 238 "recordings.ecpp"
  reply.sout() << ( history_num_back+1 );
  reply.out() << _tntChunks[28]; // );\n    s.a += '</div></div></td>'  // end if recording_name / short description\n    s.a += '<td><div class="recording_actions">'\n    if (obj[1].length == 0) {\n
#line 242 "recordings.ecpp"
     if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  reply.out() << _tntChunks[29]; //         RecordingActionS(s, obj[0], "vdr_request/play_recording\?param=", "play.png", "
#line 243 "recordings.ecpp"
  reply.sout() << (tr("play this recording"));
  reply.out() << _tntChunks[30]; // ")\n
#line 244 "recordings.ecpp"
     }

#line 245 "recordings.ecpp"
     if (LiveSetup().GetShowPlayMediaplayer() ) {

  reply.out() << _tntChunks[31]; //         RecordingActionS(s, obj[0], "playlist.m3u\?recid=", "playlist.png", "
#line 246 "recordings.ecpp"
  reply.sout() << (tr("Stream this recording into media player."));
  reply.out() << _tntChunks[32]; // \134" download=\134"playlist.m3u")\n
#line 247 "recordings.ecpp"
     } if (LiveSetup().GetShowIMDb() ) {

  reply.out() << _tntChunks[33]; //         IMDBS(s, obj[2], obj[14])\n
#line 249 "recordings.ecpp"
     }

  reply.out() << _tntChunks[34]; //       RecordingActionS(s, obj[0], "edit_recording.html\?recid=", "edit.png", "
#line 250 "recordings.ecpp"
  reply.sout() << (tr("Edit recording"));
  reply.out() << _tntChunks[35]; // ")\n      RecordingActionS(s, obj[0], "epginfo.html\?epgid=del_", "del.png", "
#line 251 "recordings.ecpp"
  reply.sout() << (tr("Delete this recording from hard disc!"));
  reply.out() << _tntChunks[36]; // ")\n
#line 252 "recordings.ecpp"
     if (LiveSetup().GetShowIMDb() ) {

  reply.out() << _tntChunks[37]; //     } else {\n      IMDBS(s, obj[2], obj[14])\n
#line 255 "recordings.ecpp"
     }

  reply.out() << _tntChunks[38]; //     }\n    s.a += '</div>'\n    if (obj[1].length != 0) {\n      s.a += '<div class="recording_arch">'\n      s.a += obj[1]\n      s.a += '</div>'\n    }\n    s.a += '</td></tr>'\n  }\n  s.a += '</table></div></li>'\n}\n\n</script>\n\n  <script type="text/javascript" src="js/live/treeview.js"></script>\n  <script>\n  const tv = new Treeview("
#line 272 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[39]; // minus.png", "
#line 272 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[40]; // plus.png", "
#line 272 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[41]; // folder_open.png", "
#line 272 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[42]; // folder_closed.png");\n  </script>\n</head>\n<body onload="adjustHeader()" onresize="adjustHeader()" onpageshow="clearCheckboxes(document.getElementById('form_recordings'))">\n  
  // <& pageelems.logo ...
  { 
#line 276 "recordings.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 276 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[43]; // \n
#line 277 "recordings.ecpp"

const char *active_r;
if (flat == "true") active_r = "recordings_flat";
else active_r = "recordings";

if (!deleteResult.empty()) {

  reply.out() << _tntChunks[44]; //   
  // <& menu ...
  { 
#line 284 "recordings.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 284 "recordings.ecpp"
    _tnt_cq5.add( "active", (active_r));
#line 284 "recordings.ecpp"
    _tnt_cq5.add( "component", "recordings.delete_error");
#line 284 "recordings.ecpp"
    _tnt_cq5.add( "filter", (filter));
#line 284 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[45]; // \n
#line 285 "recordings.ecpp"

} else {

  reply.out() << _tntChunks[46]; //   
  // <& menu ...
  { 
#line 288 "recordings.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 288 "recordings.ecpp"
    _tnt_cq6.add( "active", (active_r));
#line 288 "recordings.ecpp"
    _tnt_cq6.add( "component", "recordings.sort_options");
#line 288 "recordings.ecpp"
    _tnt_cq6.add( "filter", (filter));
#line 288 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[47]; // \n
#line 289 "recordings.ecpp"

}

  reply.out() << _tntChunks[48]; //   <div class="inhalt">\n    <div class="boxheader"><div><div>
#line 293 "recordings.ecpp"
  reply.sout() << ( std::string(tr("List of recordings")) + " (" + diskinfo + ")" );
  reply.out() << _tntChunks[49]; // </div></div></div>\n
#line 294 "recordings.ecpp"

    int rec_cnt;
    {
      LOCK_RECORDINGS_READ;
      rec_cnt = Recordings->Count();  // Access VDRs global cRecordings Recordings instance.
    }
    if (rec_cnt == 0) {

  reply.out() << _tntChunks[50]; //       
#line 302 "recordings.ecpp"
  reply.sout() << ( tr("No recordings found") );
  reply.out() << _tntChunks[51]; // \n
#line 303 "recordings.ecpp"

    } else {
      uintptr_t irecoring_item = (uintptr_t)&recoring_item;
      RecordingsItemDirPtr recItemRoot = recordingsTree->getRoot();
      uintptr_t iRecItemRoot = (uintptr_t)&recItemRoot;
      uintptr_t iRecordingsTree = (uintptr_t)&recordingsTree;
      uintptr_t iOpenTreeNodes = (uintptr_t)&openTreeNodes;
      uintptr_t iAvailable_recs = (uintptr_t)&available_recs;

  reply.out() << _tntChunks[52]; //       <form method="post" name="recordings" id="form_recordings" action="recordings.ecpp">\n        <div class="recordings">\n          <ul class="recordingslist" style="display: block;">\n            
  // <& recordings.recordings_item ...
  { 
#line 315 "recordings.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 315 "recordings.ecpp"
    _tnt_cq7.add( "iAvailable_recs", (iAvailable_recs));
#line 315 "recordings.ecpp"
    _tnt_cq7.add( "iOpenTreeNodes", (iOpenTreeNodes));
#line 315 "recordings.ecpp"
    _tnt_cq7.add( "iRecItem", (iRecItemRoot));
#line 315 "recordings.ecpp"
    _tnt_cq7.add( "iRecordingsTree", (iRecordingsTree));
#line 315 "recordings.ecpp"
    _tnt_cq7.add( "irecoring_item", (irecoring_item));
#line 315 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "recordings_item"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[53]; // \n          </ul>\n        </div>\n\t\t\t\t<input type="hidden" name="sort" value="
#line 318 "recordings.ecpp"
  reply.sout() << ( currentSort );
  reply.out() << _tntChunks[54]; // ">\n\t\t\t\t<input type="hidden" name="filter" value="
#line 319 "recordings.ecpp"
  reply.sout() << ( currentFilter );
  reply.out() << _tntChunks[55]; // ">\n\t\t\t\t<input type="hidden" name="flat" value="
#line 320 "recordings.ecpp"
  reply.sout() << ( currentFlat );
  reply.out() << _tntChunks[56]; // ">\n\t\t\t\t<input type="hidden" name="history_num_back" value="
#line 321 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[57]; // ">\n        <div class="withmargin hidden-xs">\n          <button class="red" type="submit">
#line 323 "recordings.ecpp"
  reply.sout() << ( tr("Delete selected") );
  reply.out() << _tntChunks[58]; // </button>\n
  reply.out() << _tntChunks[59]; // \n        </div>\n      </form>\n
#line 327 "recordings.ecpp"

    }
std::chrono::duration<double> timeNeeded = std::chrono::high_resolution_clock::now() - timeStart;
dsyslog("live, time recordings.ecpp: %f", timeNeeded.count());

  reply.out() << _tntChunks[60]; //   </div>\n</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[61]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[62]; // \n
  reply.out() << _tntChunks[63]; // \n\n
  reply.out() << _tntChunks[110]; // \n
  reply.out() << _tntChunks[111]; // \n
  reply.out() << _tntChunks[146]; // \n
  reply.out() << _tntChunks[147]; // \n
  reply.out() << _tntChunks[149]; // \n
  reply.out() << _tntChunks[150]; // \n
  reply.out() << _tntChunks[159]; // \n
  reply.out() << _tntChunks[160]; // \n
  reply.out() << _tntChunks[169]; // \n
  reply.out() << _tntChunks[170]; // \n
  reply.out() << _tntChunks[189]; // \n\n
  reply.out() << _tntChunks[190]; // \n
  reply.out() << _tntChunks[206]; // \n
  reply.out() << _tntChunks[207]; // \n
  reply.out() << _tntChunks[212]; // \n
  reply.out() << _tntChunks[213]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::recordings_item_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::recordings_item " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
uintptr_t iRecItem = qparam.get< uintptr_t >("iRecItem", ( 0));
uintptr_t irecoring_item = qparam.get< uintptr_t >("irecoring_item", ( 0));
uintptr_t iRecordingsTree = qparam.get< uintptr_t >("iRecordingsTree", ( 0));
uintptr_t iOpenTreeNodes = qparam.get< uintptr_t >("iOpenTreeNodes", ( 0));
uintptr_t iAvailable_recs = qparam.get< uintptr_t >("iAvailable_recs", ( 0));
std::string parentIdHash = qparam.get< std::string >("parentIdHash");
  // </%args>

#line 34 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 39 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 40 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 41 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 42 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 348 "recordings.ecpp"

// define sort order, and reverse (for recordings)
// use current sort order and selected sort option for that
bool reverse = false;
eSortOrder sortOrder = eSortOrder::name; // default
if (currentSort.compare(0, 4,  "date"  , 4) == 0) sortOrder = eSortOrder::date;
if (currentSort.compare(0, 6,  "errors", 6) == 0) sortOrder = eSortOrder::errors;
if (currentSort.compare(0, 8,  "errorsdur", 8) == 0) sortOrder = eSortOrder::durationDeviation;
if (currentSort.compare(0, 10, "duplicates", 10) == 0) sortOrder = eSortOrder::duplicatesLanguage;
if (currentSort == "datedesc" || currentSort == "namedesc") reverse = true;
// get rec item of this (current) dir
RecordingsItemDirPtr recItemThisDir = *(static_cast<RecordingsItemDirPtr *>((void *)iRecItem) );
RecordingsTreePtr recordingsTree = *(static_cast<RecordingsTreePtr *>((void *)iRecordingsTree) );
cToSvConcat<0> *recoring_item = static_cast<cToSvConcat<0> *>((void *)irecoring_item );
std::string openTreeNodes= *(static_cast<std::string *>((void *)iOpenTreeNodes) );
std::vector<int> available_recs = *(static_cast<std::vector<int> *>((void *)iAvailable_recs) );
int level = recItemThisDir->Level();


std::vector<RecordingsItemRecPtr> recItems;
const std::vector<RecordingsItemRecPtr> *recItemsC = NULL;

// data for dirs, and loop over dirs
const std::vector<RecordingsItemDirPtr> *dirItems = recItemThisDir->getDirs();
std::vector<RecordingsItemDirPtr>::const_iterator dirIterS, dirIterE, dirIter;
int direction; // for dirs
if (currentFlat != "true") {
  if (currentSort != "duplicates") {
// list of subdirs
    if (!recItemThisDir->dirEntriesSorted() && currentSort == "namedesc") {
// reverse loop over subdirs
      dirIterS = dirItems->end();
      dirIterE = dirItems->begin();
      direction = 0;
    } else {
// forward loop over subdirs
      dirIterS = dirItems->begin();
      dirIterE = dirItems->end();
      direction = 1;
    }
    for (dirIter = dirIterS; dirIter != dirIterE; std::advance(dirIter, direction) ) {
      if(direction == 0) dirIter--;
// this is the loop over the subdirs
// each subdir is a node, which can be expanded (or not)
// each subdir has an identifier in <ul> tag: fldr_<$ idHash $>
      RecordingsItemDirPtr recItem = *dirIter;

      /* search trough directory for new recordings */
      bool newR = false;
      if ( LiveSetup().GetMarkNewRec() ) newR = recItem->checkNew();
// calculate idHash: uniquely defines this node
      std::string idHash(xxHash32(concat(parentIdHash, recItem->Name())));
      iRecItem = (uintptr_t)&recItem;
  
  reply.out() << _tntChunks[64]; //       <li class="recording">\n        <div class="recording_item" onclick = "tv.Toggle(this, 'fldr_
#line 403 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[65]; // ')">\n        <table><tr>\n          
#line 405 "recordings.ecpp"
 if(level > 0) { 
  reply.out() << _tntChunks[66]; //             <td class = "space">\n              <img src="img/transparent.png" width="
#line 407 "recordings.ecpp"
  reply.sout() << ( 16*level );
  reply.out() << _tntChunks[67]; // px" height="16px" />\n            </td>\n          
#line 409 "recordings.ecpp"
 } 
  reply.out() << _tntChunks[68]; //           <td class="space">\n            <img class="recording_expander" src="
#line 411 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[69]; // plus.png" />\n          </td><td class="space">\n            <img class="recording_folder" src="
#line 413 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[70]; // folder_closed.png" />\n          </td>\n
#line 415 "recordings.ecpp"
         if (!recItem->scraperImage().path.empty() ) {

  reply.out() << _tntChunks[71]; //             <td class = space>\n              <div class="thumb">\n                <img data-src="/tvscraper/
#line 418 "recordings.ecpp"
  reply.sout() << ( recItem->scraperImage().path );
  reply.out() << _tntChunks[72]; // "\n                  class="
#line 419 "recordings.ecpp"
  reply.sout() << ( recItem->scraperImage().width > recItem->scraperImage().height?"thumb":"thumbpt" );
  reply.out() << _tntChunks[73]; // "\n                />\n              </div>\n            </td>\n
#line 423 "recordings.ecpp"
         }

  reply.out() << _tntChunks[74]; //         <td class="recording_folder_name
#line 424 "recordings.ecpp"
  reply.sout() << ( (newR ? "_new" : "") );
  reply.out() << _tntChunks[75]; // ">\n          
#line 425 "recordings.ecpp"
  reply.sout() << ( recItem->Name() );
  reply.out() << _tntChunks[76]; // \n        </td></tr></table>\n        </div>\n        <ul id="fldr_
#line 428 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[77]; // " class="recordingslist" style="display: none;">\n          
  // <& recordings.recordings_item ...
  { 
#line 429 "recordings.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 429 "recordings.ecpp"
    _tnt_cq8.add( "iAvailable_recs", (iAvailable_recs));
#line 429 "recordings.ecpp"
    _tnt_cq8.add( "iOpenTreeNodes", (iOpenTreeNodes));
#line 429 "recordings.ecpp"
    _tnt_cq8.add( "iRecItem", (iRecItem));
#line 429 "recordings.ecpp"
    _tnt_cq8.add( "iRecordingsTree", (iRecordingsTree));
#line 429 "recordings.ecpp"
    _tnt_cq8.add( "irecoring_item", (irecoring_item));
#line 429 "recordings.ecpp"
    _tnt_cq8.add( "parentIdHash", (idHash));
#line 429 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "recordings_item"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[78]; // \n        </ul>\n      </li>\n      
#line 432 "recordings.ecpp"

    } // end of loop over subdirs
// now the items
    recItemsC = recItemThisDir->getRecordings(sortOrder);
    if (recItemThisDir->recEntriesSorted() ) reverse = false;
  } // end if (currentSort != "duplicates")
} else {
// here we prepare the items in case of a flat list, no folders
  if (currentSort != "duplicates") {
    recItems.clear();
    size_t max_items = 100;
    if (reverse) {
      reverse = false;
      std::vector<RecordingsItemRecPtr>::const_iterator recIterFirst = recordingsTree->allRecordings(sortOrder)->begin();
      std::vector<RecordingsItemRecPtr>::const_iterator recIterLast  = recordingsTree->allRecordings(sortOrder)->end();
      for (; recIterFirst != recIterLast;) {
        --recIterLast;
        RecordingsItemRecPtr recItem = *recIterLast;
        if (!recItem->matchesFilter(currentFilter)) continue;
        recItems.push_back(recItem);
        if (recItems.size() >= max_items) break;
      }
     } else {
      for (const RecordingsItemRecPtr &rPtr: *recordingsTree->allRecordings(sortOrder) ) {
        if (!rPtr->matchesFilter(currentFilter)) continue;
        recItems.push_back(rPtr);
        if (recItems.size() >= max_items) break;
      }
    }
//    recItemsC = recordingsTree->allRecordings(sortOrder);
    recItemsC = &recItems;
  } else {
    recItems.clear();
    addDuplicateRecordingsSd(recItems, recordingsTree);
    addDuplicateRecordingsLang(recItems, recordingsTree);
    addDuplicateRecordingsNoSd(recItems, recordingsTree);
    recItemsC = &recItems;
  }
}
// do we have to get/write the recording details?
// we have to, if currentFlat == true || level == 0 || this folder is open (cookie)
bool write_recs = level == 0 || currentFlat == "true";
if (!write_recs && recItemsC) {
// check: is this folder open (cookie)?
  auto equal_fldf = [parentIdHash](cSv f) { return f.compare(5, std::string_view::npos, parentIdHash) == 0; };
  cSplit splitOpenTreeNodes(openTreeNodes, ',');
  write_recs = std::find_if(splitOpenTreeNodes.begin(), splitOpenTreeNodes.end(), equal_fldf) != splitOpenTreeNodes.end();
}
if (write_recs && recItemsC) {
// in case of duplicates, and not flat, the recItemsC is not available
  
  reply.out() << _tntChunks[79]; // <script>\n  
#line 484 "recordings.ecpp"

  for (const RecordingsItemRecPtr &rPtr: *recItemsC) {
    recoring_item->clear();
    rPtr->AppendAsJSArray(*recoring_item);
  
  reply.out() << _tntChunks[80]; // recs[
#line 489 "recordings.ecpp"
  reply.sout() << (cSv(cToSvInt(rPtr->IdI())));
  reply.out() << _tntChunks[81]; // ]=[
#line 489 "recordings.ecpp"
  reply.out() << ( recoring_item->c_str() );
  reply.out() << _tntChunks[82]; // ]\n
#line 490 "recordings.ecpp"
 }

  reply.out() << _tntChunks[83]; // </script>\n  
#line 492 "recordings.ecpp"

}
if (currentSort != "duplicates" || currentFlat == "true") {
  if (recItemsC->empty() ) { 
  reply.out() << _tntChunks[84]; //     <script>\n      rec_ids["fldr_
#line 497 "recordings.ecpp"
  reply.sout() << ( parentIdHash );
  reply.out() << _tntChunks[85]; // "] = []\n    </script>\n  
#line 499 "recordings.ecpp"
 } else {
    bool first = true;
//    const char *displayFolder = currentFlat == "true"?"1":"0";
    const char *displayFolder = "1";
    recoring_item->clear();
    RecordingsItemRec::AppendAsJSArray(*recoring_item, recItemsC->begin(), recItemsC->end(), first, currentFilter, reverse);
    
  reply.out() << _tntChunks[86]; //       <script>\n
#line 507 "recordings.ecpp"
   if (level == 0) {

  reply.out() << _tntChunks[87]; //       document.write(rec_string_d([
#line 508 "recordings.ecpp"
  reply.sout() << (level);
  reply.out() << _tntChunks[88]; // , 
#line 508 "recordings.ecpp"
  reply.sout() << (displayFolder);
  reply.out() << _tntChunks[89]; // , [ 
#line 508 "recordings.ecpp"
  reply.out() << ( recoring_item->c_str() );
  reply.out() << _tntChunks[90]; //  ]]))\n
#line 509 "recordings.ecpp"
   } else {

  reply.out() << _tntChunks[91]; //       rec_ids["fldr_
#line 510 "recordings.ecpp"
  reply.sout() << ( parentIdHash );
  reply.out() << _tntChunks[92]; // "] = [
#line 510 "recordings.ecpp"
  reply.sout() << (level);
  reply.out() << _tntChunks[93]; // , 
#line 510 "recordings.ecpp"
  reply.sout() << (displayFolder);
  reply.out() << _tntChunks[94]; // , [ 
#line 510 "recordings.ecpp"
  reply.out() << ( recoring_item->c_str() );
  reply.out() << _tntChunks[95]; //  ]]\n
#line 511 "recordings.ecpp"
   }

  reply.out() << _tntChunks[96]; //       </script>\n    
#line 513 "recordings.ecpp"

  }
} else {
// duplicates
  for (int i = 0; i < 3; i++) {
    recItems.clear();
    std::string nodeName;
    if (i == 0) {
      addDuplicateRecordingsSd(recItems, recordingsTree);
      nodeName = tr("Duplicates identified by tvscraper");
    } else if (i == 1) {
      addDuplicateRecordingsLang(recItems, recordingsTree);
      nodeName = tr("Duplicates, with different languages");
    } else if (i == 2) {
      addDuplicateRecordingsNoSd(recItems, recordingsTree);
      nodeName = tr("Duplicates not identified by tvscraper");
    }
    if (!recItems.empty() ) {
      std::string idHash(xxHash32(nodeName));
// do we have to get/write the recording details?
// check: is this folder open (cookie)?
      auto equal_fldf = [idHash](cSv f) { return f.compare(5, std::string_view::npos, idHash) == 0; };
      cSplit splitOpenTreeNodes(openTreeNodes, ',');
      if (std::find_if(splitOpenTreeNodes.begin(), splitOpenTreeNodes.end(), equal_fldf) != splitOpenTreeNodes.end()) {
        
  reply.out() << _tntChunks[97]; // <script>\n        
#line 539 "recordings.ecpp"

        for (const RecordingsItemRecPtr &rPtr: recItems) {
          recoring_item->clear();
          rPtr->AppendAsJSArray(*recoring_item);
          
  reply.out() << _tntChunks[98]; // recs[
#line 544 "recordings.ecpp"
  reply.sout() << (cSv(cToSvInt(rPtr->IdI())));
  reply.out() << _tntChunks[99]; // ]=[
#line 544 "recordings.ecpp"
  reply.out() << ( recoring_item->c_str() );
  reply.out() << _tntChunks[100]; // ]\n
#line 545 "recordings.ecpp"
       }

  reply.out() << _tntChunks[101]; // </script>\n      
#line 547 "recordings.ecpp"

      }
      bool first = true;
      recoring_item->clear();
      RecordingsItemRec::AppendAsJSArray(*recoring_item, recItems.begin(), recItems.end(), first, currentFilter, false);
      
  reply.out() << _tntChunks[102]; //       <li class="recording">\n        <div class="recording_item" onclick = "tv.Toggle(this, 'fldr_
#line 554 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[103]; // ')">\n          <table><tr><td class="space">\n            <img class="recording_expander" src="
#line 556 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[104]; // plus.png" />\n          </td><td class="space">\n            <img class="recording_folder" src="
#line 558 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[105]; // folder_closed.png" />\n          </td><td class="recording_folder_name">\n            
#line 560 "recordings.ecpp"
  reply.sout() << ( nodeName );
  reply.out() << _tntChunks[106]; // \n          </td></tr></table>\n        </div>\n        <ul id="fldr_
#line 563 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[107]; // " class="recordingslist" style="display: none;">\n          <script>\n            rec_ids["fldr_
#line 565 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[108]; // "] = [1, 1, [ 
#line 565 "recordings.ecpp"
  reply.out() << ( recoring_item->c_str() );
  reply.out() << _tntChunks[109]; //  ]]\n          </script>\n        </ul>\n      </li>\n      
#line 569 "recordings.ecpp"

    }
  }
}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::sort_options_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::sort_options " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 34 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 39 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 40 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 41 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 42 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 578 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[112]; // <span class="label bold">
#line 579 "recordings.ecpp"
  reply.sout() << ( tr("Sort:") );
  reply.out() << _tntChunks[113]; //  </span>\n<a href="recordings.html\?sort=
#line 580 "recordings.ecpp"
  reply.sout() << ( (currentSort == "nameasc") ? "namedesc" : "nameasc");
  reply.out() << _tntChunks[114]; // &filter=
#line 580 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[115]; // &flat=
#line 580 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[116]; // " 
  // <& setactive ...
  { 
#line 580 "recordings.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 580 "recordings.ecpp"
    _tnt_cq9.add( "current", "name");
#line 580 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[117]; //  >
#line 580 "recordings.ecpp"
  reply.sout() << ( tr("Name") );
  reply.out() << _tntChunks[118]; // </a>\n<span class="sep">|</span>\n<a href="recordings.html\?sort=
#line 582 "recordings.ecpp"
  reply.sout() << ( (currentSort == "datedesc") ? "dateasc" : "datedesc");
  reply.out() << _tntChunks[119]; // &filter=
#line 582 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[120]; // &flat=
#line 582 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[121]; // " 
  // <& setactive ...
  { 
#line 582 "recordings.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 582 "recordings.ecpp"
    _tnt_cq10.add( "current", "date");
#line 582 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[122]; //  >
#line 582 "recordings.ecpp"
  reply.sout() << ( tr("Date") );
  reply.out() << _tntChunks[123]; // </a>\n<span class="sep">|</span>\n<a href="recordings.html\?sort=duplicates&filter=
#line 584 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[124]; // &flat=
#line 584 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[125]; // " 
  // <& setactive ...
  { 
#line 584 "recordings.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 584 "recordings.ecpp"
    _tnt_cq11.add( "current", "duplicates");
#line 584 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[126]; //  >
#line 584 "recordings.ecpp"
  reply.sout() << ( tr("Duplicates") );
  reply.out() << _tntChunks[127]; // </a>\n
#line 585 "recordings.ecpp"

#if VDRVERSNUM >= 20505

  reply.out() << _tntChunks[128]; // <span class="sep">|</span>\n<a href="recordings.html\?sort=
#line 589 "recordings.ecpp"
  reply.sout() << ( (currentSort == "errorsts") ? "errorsdur" : "errorsts" );
  reply.out() << _tntChunks[129]; // &filter=
#line 589 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[130]; // &flat=
#line 589 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[131]; // " 
  // <& setactive ...
  { 
#line 589 "recordings.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 589 "recordings.ecpp"
    _tnt_cq12.add( "current", "errors");
#line 589 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[132]; // >
#line 589 "recordings.ecpp"
  reply.sout() << ( tr("Errors") );
  reply.out() << _tntChunks[133]; // </a>\n
#line 590 "recordings.ecpp"

#endif
#ifdef HAVE_PCRE2

  reply.out() << _tntChunks[134]; // <span class="sep">|</span>\n<span class="label bold">
#line 595 "recordings.ecpp"
  reply.sout() << ( tr("Filter") );
  reply.out() << _tntChunks[135]; // :&nbsp;<input type="text" name="filter" value="
#line 595 "recordings.ecpp"
  reply.sout() << ( currentFilter );
  reply.out() << _tntChunks[136]; // " id="filter" onchange="filterRecordings(this, '
#line 595 "recordings.ecpp"
  reply.sout() << ( currentSort );
  reply.out() << _tntChunks[137]; // ', '
#line 595 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[138]; // ')" />&nbsp;
  // <& tooltip.help ...
  { 
#line 595 "recordings.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 595 "recordings.ecpp"
    _tnt_cq13.add( "text", (tr("Look in recordings titles and subtitles for the given string and display only the matching ones. You may also use perl compatible regular expressions (PCRE).")));
#line 595 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[139]; // </span>\n
#line 596 "recordings.ecpp"

#endif
if (currentFlat != "true") {

  reply.out() << _tntChunks[140]; // <span class="sep">|</span>\n<img onclick="ExpandAll()" src="
#line 601 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "plus.png") );
  reply.out() << _tntChunks[141]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 601 "recordings.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 601 "recordings.ecpp"
    _tnt_cq14.add( "text", (tr("Expand all folders")));
#line 601 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[142]; // />\n<img onclick="CollapseAll()" src="
#line 602 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "minus.png") );
  reply.out() << _tntChunks[143]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 602 "recordings.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 602 "recordings.ecpp"
    _tnt_cq15.add( "text", (tr("Collapse all folders")));
#line 602 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[144]; // />\n
#line 603 "recordings.ecpp"

}

  reply.out() << _tntChunks[145]; // <br />\n
#line 607 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::setactive_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::setactive " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string current = qparam.get< std::string >("current");
  // </%args>

#line 34 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 39 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 40 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 41 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 42 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 615 "recordings.ecpp"

if (currentSort.compare(0, current.length(), current) == 0) { 
  reply.out() << _tntChunks[148]; // class="active"
#line 616 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::del_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::del_rec " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string sort = qparam.get< std::string >("sort");
std::string filter = qparam.get< std::string >("filter");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 34 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 39 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 40 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 41 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 42 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 628 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[151]; // <a href="epginfo.html\?epgid=del_
#line 628 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[152]; // &sort=
#line 628 "recordings.ecpp"
  reply.sout() << (sort);
  reply.out() << _tntChunks[153]; // &filter=
#line 628 "recordings.ecpp"
  reply.sout() << (filter);
  reply.out() << _tntChunks[154]; // &flat=
#line 628 "recordings.ecpp"
  reply.sout() << (flat);
  reply.out() << _tntChunks[155]; // &history_num_back=
#line 628 "recordings.ecpp"
  reply.sout() << (history_num_back+1);
  reply.out() << _tntChunks[156]; // " 
  // <& tooltip.hint ...
  { 
#line 628 "recordings.ecpp"
    tnt::QueryParams _tnt_cq16;
#line 628 "recordings.ecpp"
    _tnt_cq16.add( "text", (tr("Delete this recording from hard disc!")));
#line 628 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq16);
    // &>
  }
  reply.out() << _tntChunks[157]; // ><img src="
#line 628 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[158]; // " alt="" /></a>
#line 628 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::edit_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::edit_rec " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string sort = qparam.get< std::string >("sort");
std::string filter = qparam.get< std::string >("filter");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 34 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 39 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 40 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 41 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 42 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 640 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[161]; // <a href="edit_recording.html\?recid=
#line 640 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[162]; // &sort=
#line 640 "recordings.ecpp"
  reply.sout() << (sort);
  reply.out() << _tntChunks[163]; // &filter=
#line 640 "recordings.ecpp"
  reply.sout() << (filter);
  reply.out() << _tntChunks[164]; // &flat=
#line 640 "recordings.ecpp"
  reply.sout() << (flat);
  reply.out() << _tntChunks[165]; // &history_num_back=
#line 640 "recordings.ecpp"
  reply.sout() << (history_num_back+1);
  reply.out() << _tntChunks[166]; // "><img src="
#line 640 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "edit.png") );
  reply.out() << _tntChunks[167]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 640 "recordings.ecpp"
    tnt::QueryParams _tnt_cq17;
#line 640 "recordings.ecpp"
    _tnt_cq17.add( "text", (tr("Edit recording")));
#line 640 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq17);
    // &>
  }
  reply.out() << _tntChunks[168]; //  /></a>
#line 640 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::todel_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::todel " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string todel = qparam.get< std::string >("todel");
std::string confirmed = qparam.get< std::string >("confirmed");
std::string history_num_back = qparam.get< std::string >("history_num_back");
  // </%args>

#line 34 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 39 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 40 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 41 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 42 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 650 "recordings.ecpp"

  RecordingsManagerPtr recordings = LiveRecordingsManager();
  const cRecording *recording = recordings->GetByMd5Hash(todel);
  if (recording == nullptr)
    throw HtmlError(tr("Couldn't find recording or no recordings available"));
  if (!cUser::CurrentUserHasRightTo(UR_DELRECS))
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
  if (confirmed == "confirmed") {
    RemoveRecordingTask task(todel);
    LiveTaskManager().Execute(task);

  reply.out() << _tntChunks[171]; // <!DOCTYPE html>\n<html>\n  <script>\n    history.go(-
#line 664 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[172]; // );\n  </script>\n</html>\n
#line 667 "recordings.ecpp"
  } else {

  reply.out() << _tntChunks[173]; // <div class="epg_description" id="del_
#line 668 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[174]; // ">\n  <div class="station">\n    <div class="boxheader"><div><div class="caption">
#line 670 "recordings.ecpp"
  reply.sout() << ( tr("Delete recordings") );
  reply.out() << _tntChunks[175]; // </div></div></div>\n  </div>\n  <div class="epg_content">\n    <form>\n      <div class="about_head"><div><div>
#line 674 "recordings.ecpp"
  reply.sout() << ( cSv(cToSvFormated(tr("Delete recording \"%s\"?"), recording->Name()?recording->Name():"No recording name available")) );
  reply.out() << _tntChunks[176]; // </div></div></div>\n      <input type="hidden" name="epgid" value="
#line 675 "recordings.ecpp"
  reply.sout() << (todel);
  reply.out() << _tntChunks[177]; // " >\n      <input type="hidden" name="delete_rec" value="confirmed" >\n      <input type="hidden" name="history_num_back" value="
#line 677 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[178]; // " id="history_del_
#line 677 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[179]; // ">\n      <div class="about_left">\n        <button id="confirm_del_
#line 679 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[180]; // " class="green" type="button" onclick="delete_rec_back('
#line 679 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[181]; // ', 
#line 679 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[182]; // )">
#line 679 "recordings.ecpp"
  reply.sout() << ( tr("Delete"));
  reply.out() << _tntChunks[183]; // </button>\n      </div>\n      <div class="about_right">\n
  reply.out() << _tntChunks[184]; // \n<script>\nfunction cancel_delete() {\n  if (document.referrer.indexOf("epginfo.html\?") != -1) {\n    history.go(-1);\n  } else {\n    history.go(-
#line 688 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[185]; // );\n  }\n}\n</script>\n        <button id="close_del_
#line 692 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[186]; // " type="button" class="red" onclick="back_depending_referrer(1, 
#line 692 "recordings.ecpp"
  reply.sout() << (history_num_back );
  reply.out() << _tntChunks[187]; // )">
#line 692 "recordings.ecpp"
  reply.sout() << ( tr("Cancel") );
  reply.out() << _tntChunks[188]; // </button>\n      </div>\n    </form>\n  </div>\n</div>\n
#line 697 "recordings.ecpp"
 }

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::rec_tools_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::rec_tools " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
std::string sort = qparam.get< std::string >("sort");
std::string filter = qparam.get< std::string >("filter");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 34 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 39 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 40 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 41 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 42 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 712 "recordings.ecpp"
   if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  // <& pageelems.ajax_action_href ...
  { 
#line 713 "recordings.ecpp"
    tnt::QueryParams _tnt_cq18;
#line 713 "recordings.ecpp"
    _tnt_cq18.add( "action", "play_recording");
#line 713 "recordings.ecpp"
    _tnt_cq18.add( "alt", "");
#line 713 "recordings.ecpp"
    _tnt_cq18.add( "image", "play.png");
#line 713 "recordings.ecpp"
    _tnt_cq18.add( "param", (id));
#line 713 "recordings.ecpp"
    _tnt_cq18.add( "tip", (tr("play this recording")));
#line 713 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq18);
    // &>
  }
  reply.out() << _tntChunks[191]; // \n
#line 714 "recordings.ecpp"
   }

  // <& pageelems.m3u_playlist_recording ...
  { 
#line 715 "recordings.ecpp"
    tnt::QueryParams _tnt_cq19;
#line 715 "recordings.ecpp"
    _tnt_cq19.add( "recid", (id));
#line 715 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_recording"), request, reply, _tnt_cq19);
    // &>
  }
  reply.out() << _tntChunks[192]; // \n
  // <& pageelems.imdb_info_href ...
  { 
#line 716 "recordings.ecpp"
    tnt::QueryParams _tnt_cq20;
#line 716 "recordings.ecpp"
    _tnt_cq20.add( "s_IMDB_ID", (s_IMDB_ID));
#line 716 "recordings.ecpp"
    _tnt_cq20.add( "title", (title));
#line 716 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq20);
    // &>
  }
  reply.out() << _tntChunks[193]; // \n
  // <& recordings.edit_rec ...
  { 
#line 717 "recordings.ecpp"
    tnt::QueryParams _tnt_cq21;
#line 717 "recordings.ecpp"
    _tnt_cq21.add( "filter", (filter));
#line 717 "recordings.ecpp"
    _tnt_cq21.add( "flat", (flat));
#line 717 "recordings.ecpp"
    _tnt_cq21.add( "history_num_back", (history_num_back));
#line 717 "recordings.ecpp"
    _tnt_cq21.add( "id", (id));
#line 717 "recordings.ecpp"
    _tnt_cq21.add( "sort", (sort));
#line 717 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "edit_rec"), request, reply, _tnt_cq21);
    // &>
  }
  reply.out() << _tntChunks[194]; // \n
  // <& recordings.del_rec ...
  { 
#line 718 "recordings.ecpp"
    tnt::QueryParams _tnt_cq22;
#line 718 "recordings.ecpp"
    _tnt_cq22.add( "filter", (filter));
#line 718 "recordings.ecpp"
    _tnt_cq22.add( "flat", (flat));
#line 718 "recordings.ecpp"
    _tnt_cq22.add( "history_num_back", (history_num_back));
#line 718 "recordings.ecpp"
    _tnt_cq22.add( "id", (id));
#line 718 "recordings.ecpp"
    _tnt_cq22.add( "sort", (sort));
#line 718 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "del_rec"), request, reply, _tnt_cq22);
    // &>
  }
  reply.out() << _tntChunks[195]; // \n
#line 719 "recordings.ecpp"

const cRecording* recording = NULL;
if (!id.empty()) recording = LiveRecordingsManager()->GetByMd5Hash(id);
if (recording && recording->Info() ) {
  int recordingErrors = -1;
#if VDRVERSNUM >= 20505
  recordingErrors = recording->Info()->Errors();
#endif
  const char *sdhd = nullptr;
  cToSvConcat frameParams;
#if VDRVERSNUM >= 20605
  StringAppendFrameParams(frameParams, recording);
  switch (recording->Info()->FrameWidth()) {
    case 720:
      sdhd = "720x576";
      break;
    case 1280:
      sdhd = "1280x720";
      break;
    case 1920:
      sdhd = "1920x1080";
      break;
    case 3840:
      sdhd = "3840x2160";
      break;
    default:
      break;
  }
#endif

  cGetScraperVideo getScraperVideo(NULL, recording);
  bool scraperDataAvailable = getScraperVideo.call(LiveSetup().GetPluginScraper());
  if (scraperDataAvailable) {
    int video_SD_HD = getScraperVideo.m_scraperVideo->getHD();
    if (!sdhd) sdhd = video_SD_HD == 0 ? "sd": video_SD_HD == 1 ? "hd": "ud";
    std::string duration;
    if (recording->FileName() )
      AppendDuration(duration, tr("%d:%02d"), recording->LengthInSeconds() );

  reply.out() << _tntChunks[196]; // <img data-src="img/transparent.png" height="10px" />\n<span id="icons-
#line 759 "recordings.ecpp"
  reply.sout() << (id);
  reply.out() << _tntChunks[197]; // "></span>\n<script class="injectIcons">\ninjectErrorHdSdIcon("icons-
#line 761 "recordings.ecpp"
  reply.sout() << (id);
  reply.out() << _tntChunks[198]; // ", 
#line 761 "recordings.ecpp"
  reply.sout() << (cSv(cToSvInt(recordingErrors)));
  reply.out() << _tntChunks[199]; // , 
#line 761 "recordings.ecpp"
  reply.sout() << (cSv(cToSvInt(getScraperVideo.m_scraperVideo->getDurationDeviation())));
  reply.out() << _tntChunks[200]; // , "
#line 761 "recordings.ecpp"
  reply.sout() << (sdhd);
  reply.out() << _tntChunks[201]; // ", "
#line 761 "recordings.ecpp"
  reply.sout() << (cSv(recording->Info()->ChannelName()));
  reply.out() << _tntChunks[202]; // ", "
#line 761 "recordings.ecpp"
  reply.sout() << (duration);
  reply.out() << _tntChunks[203]; // ", 
#line 761 "recordings.ecpp"
  reply.sout() << ( GetNumberOfTsFiles(recording) );
  reply.out() << _tntChunks[204]; // , "
#line 761 "recordings.ecpp"
  reply.sout() << (frameParams);
  reply.out() << _tntChunks[205]; // ")\n</script>\n
#line 763 "recordings.ecpp"

  }
}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::archived_disc_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::archived_disc " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string archived = qparam.get< std::string >("archived");
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 34 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 39 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 40 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 41 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 42 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[208]; // <img src="
#line 776 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "on_dvd.png") );
  reply.out() << _tntChunks[209]; // " alt="on_dvd" 
  // <& tooltip.hint ...
  { 
#line 776 "recordings.ecpp"
    tnt::QueryParams _tnt_cq23;
#line 776 "recordings.ecpp"
    _tnt_cq23.add( "text", (archived));
#line 776 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq23);
    // &>
  }
  reply.out() << _tntChunks[210]; //  />\n
  // <& pageelems.imdb_info_href ...
  { 
#line 777 "recordings.ecpp"
    tnt::QueryParams _tnt_cq24;
#line 777 "recordings.ecpp"
    _tnt_cq24.add( "s_IMDB_ID", (s_IMDB_ID));
#line 777 "recordings.ecpp"
    _tnt_cq24.add( "title", (title));
#line 777 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq24);
    // &>
  }
  reply.out() << _tntChunks[211]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::delete_error_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::delete_error " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 34 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 39 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 40 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 41 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 42 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <& recordings.sort_options ...
  { 
#line 782 "recordings.ecpp"
    tnt::QueryParams _tnt_cq25;
#line 782 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "sort_options"), request, reply, _tnt_cq25);
    // &>
  }
  reply.out() << _tntChunks[214]; // \n
#line 783 "recordings.ecpp"
 { reply.out() << deleteResult; } 
  // <%/cpp>
  return DEFAULT;
}

} // namespace
